Imports System.Windows.forms
Imports System.Drawing

Public Class FormControls

    Public Class MyText
        Inherits TextBox
        Public Sub New()
            MyBase.new()
            Text = ""
            Width = 200
            Enabled = False
        End Sub
        Public Sub EnterHandler(ByVal Sender As Object, ByVal e As EventArgs) Handles MyBase.Enter
            ForeColor = ForeColor.White
            BackColor = BackColor.Blue
        End Sub
        Public Sub LeaveHandler(ByVal Sender As Object, ByVal e As EventArgs) Handles MyBase.Leave
            ForeColor = ForeColor.Black
            BackColor = BackColor.White
        End Sub
        Public Sub DisableHandler(ByVal Sender As Object, ByVal e As EventArgs) Handles MyBase.EnabledChanged
            Sender.BackColor = IIf(Sender.enabled, BackColor.White, System.Drawing.SystemColors.ControlLight)
        End Sub
    End Class

    Public Class MyEdit
        Inherits TextBox
        Public Sub New()
            MyBase.new()
            Text = ""
            Width = 200
            Multiline = True
            Enabled = False
        End Sub
        Public Sub EnterHandler(ByVal Sender As Object, ByVal e As EventArgs) Handles MyBase.Enter
            ForeColor = ForeColor.White
            BackColor = BackColor.Blue
        End Sub
        Public Sub LeaveHandler(ByVal Sender As Object, ByVal e As EventArgs) Handles MyBase.Leave
            ForeColor = ForeColor.Black
            BackColor = BackColor.White
        End Sub
        Public Sub DisableHandler(ByVal Sender As Object, ByVal e As EventArgs) Handles MyBase.EnabledChanged
            Sender.BackColor = IIf(Sender.enabled, BackColor.White, System.Drawing.SystemColors.ControlLight)
        End Sub
    End Class

    Public Class MyCombo
        Inherits ComboBox
        Public Sub New()
            MyBase.new()
            Text = ""
            Width = 200
            Enabled = False
        End Sub
        Public Sub EnterHandler(ByVal Sender As Object, ByVal e As EventArgs) Handles MyBase.Enter
            ForeColor = ForeColor.White
            BackColor = BackColor.Blue
        End Sub
        Public Sub LeaveHandler(ByVal Sender As Object, ByVal e As EventArgs) Handles MyBase.Leave
            ForeColor = ForeColor.Black
            BackColor = BackColor.White
        End Sub
        Public Sub DisableHandler(ByVal Sender As Object, ByVal e As EventArgs) Handles MyBase.EnabledChanged
            Sender.BackColor = IIf(Sender.enabled, BackColor.White, System.Drawing.SystemColors.ControlLight)
        End Sub
    End Class

    Public Class MyCheck
        Inherits CheckBox
        Public Sub New()
            MyBase.new()
            Text = ""
            Width = 200
            Enabled = False
        End Sub
    End Class

    Public Class MyRadio
        Inherits RadioButton
        Public Sub New()
            MyBase.new()
            Text = ""
            Width = 200
            Enabled = False
        End Sub
    End Class

    Public Class MyLabel
        Inherits Label
        Public Sub New()
            MyBase.new()
            Text = ""
            TextAlign = ContentAlignment.MiddleRight
            Height = 12
        End Sub
    End Class

End Class
