Imports System.Windows.forms
Imports System.Drawing

Public Class FormControls

    Public Class MyText
        Inherits TextBox
        Public Sub New()
            MyBase.new()
            Text = ""
            Width = 200
            Enabled = False
            BackColor = System.Drawing.SystemColors.ControlLight
        End Sub
        Public Sub EnterHandler( _
          ByVal Sender As Object, ByVal e As EventArgs) _
         Handles MyBase.Enter
            ForeColor = ForeColor.White
            BackColor = BackColor.Blue
        End Sub
        Public Sub LeaveHandler( _
          ByVal Sender As Object, ByVal e As EventArgs) _
         Handles MyBase.Leave
            ForeColor = ForeColor.Black
            BackColor = BackColor.White
        End Sub
        Public Sub DisableHandler( _
          ByVal Sender As Object, ByVal e As EventArgs) _
         Handles MyBase.EnabledChanged
            Sender.BackColor = _
             IIf(Sender.enabled, _
                 BackColor.White, _
                 System.Drawing.SystemColors.ControlLight)
        End Sub
    End Class

    Public Class MyEdit
        Inherits TextBox
        Public Sub New()
            MyBase.new()
            Text = ""
            Width = 200
            Multiline = True
            Enabled = False
            BackColor = System.Drawing.SystemColors.ControlLight
        End Sub
        Public Sub EnterHandler( _
          ByVal Sender As Object, ByVal e As EventArgs) _
         Handles MyBase.Enter
            ForeColor = ForeColor.White
            BackColor = BackColor.Blue
        End Sub
        Public Sub LeaveHandler( _
          ByVal Sender As Object, ByVal e As EventArgs) _
         Handles MyBase.Leave
            ForeColor = ForeColor.Black
            BackColor = BackColor.White
        End Sub
        Public Sub DisableHandler( _
          ByVal Sender As Object, ByVal e As EventArgs) _
         Handles MyBase.EnabledChanged
            Sender.BackColor = _
             IIf(Sender.enabled, _
                 BackColor.White, _
                 System.Drawing.SystemColors.ControlLight)
        End Sub
    End Class

    Public Class MyCombo
        Inherits ComboBox
        Public Sub New()
            MyBase.new()
            Text = ""
            Width = 200
            Enabled = False
            BackColor = System.Drawing.SystemColors.ControlLight
        End Sub

        Public Sub DisableHandler( _
          ByVal Sender As Object, _
          ByVal e As EventArgs) _
         Handles MyBase.EnabledChanged
            Sender.BackColor = _
             IIf(Sender.enabled, _
                  BackColor.White, _
                  System.Drawing.SystemColors.ControlLight)
        End Sub
    End Class

    Public Class MyCheck
        Inherits CheckBox
        Public Sub New()
            MyBase.new()
            Text = ""
            Width = 200
            Enabled = False
        End Sub
    End Class

    Public Class MyRadio
        Inherits RadioButton
        Public Sub New()
            MyBase.new()
            Text = ""
            Width = 200
            Enabled = False
        End Sub
    End Class

    Public Class MyLabel
        Inherits Label
        Public Sub New()
            MyBase.new()
            Text = ""
            TextAlign = ContentAlignment.MiddleRight
            Height = 12
        End Sub
    End Class

    Public Class MySelfLoadingCombo
        Inherits MyCombo
        Private _TableName As String = ""
        Private _DisplayName As String = ""
        Private _ValueName As String = ""

        Public Property TableName() As String
            Get
                Return _TableName
            End Get
            Set(ByVal Value As String)
                _TableName = Value
            End Set
        End Property

        Public Property DisplayName() As String
            Get
                Return _DisplayName
            End Get
            Set(ByVal Value As String)
                _DisplayName = Value
            End Set
        End Property

        Public Property ValueName() As String
            Get
                Return _ValueName
            End Get
            Set(ByVal Value As String)
                _ValueName = Value
            End Set
        End Property

        Public Sub New()
            MyBase.New()
            Enabled = True
            Tag = "SELFLOADING"
        End Sub

        Public Sub LoadData()
            If TableName <> "" Then
                Dim DataAccess As New DataAccessManager.DataAccessFileManager
                DataAccess.ReadFile()
                Dim ConnStr As String
                ConnStr = DataAccess.ConnString
                DataAccess = Nothing
                Dim SqlCmd As String = "SELECT " + ValueName + "," _
                 + DisplayName + " FROM " + TableName _
                 + " ORDER BY " + DisplayName
                Dim sda As New SqlClient.SqlDataAdapter(SqlCmd, ConnStr)
                Dim dt As New DataTable
                sda.Fill(dt)
                DataSource = dt
                DisplayMember = DisplayName
                ValueMember = ValueName
                sda = Nothing
            End If
        End Sub

    End Class

End Class