DEFINE CLASS DataMgr AS Relation

Name	  = [DataMgr]

Access	  = [SQL]
Handle	  = 0

IPAddress = [localhost]
Prefix    = [/wconnect/wc.dll?InetDataMgr~]


PROCEDURE ConnectToSQL
=SQLDISCONNECT(0)
THIS.Handle = SQLSTRINGCONNECT( [Driver={SQL Server};Server=(local);Database=Pinter;uid=Les;pwd=xyz;] )
? [Connected to SQL: Handle value is ] + TRANSFORM(THIS.Handle)
ENDPROC


PROCEDURE  OpenFile
PARAMETERS strTable, IndexTag
IF NOT USED	( strTable )
   SELECT 0
USE 		( strTable )
ENDIF
SELECT		( strTable )
IF NOT EMPTY		( IndexTag  )
   SET ORDER TO TAG ( IndexTag )
ENDIF
ENDPROC


PROCEDURE GetAccess
PARAMETERS strTable
PrevAlias = ALIAS()
THIS.OpenFile ( [TabList] )
LOCATE FOR UPPER(TableName) = UPPER(strTable)
strAccess = ALLTRIM ( TabList.Access )
USE
IF NOT EMPTY ( PrevAlias )
   SELECT    ( PrevAlias )
ENDIF
RETURN strAccess
ENDPROC


PROCEDURE UseDBFOrCursor
PARAMETERS strAccess, strTable, strTag
DO CASE
   CASE strAccess = [DBF]
		IF NOT USED ( strTable )
		   SELECT 0
		   USE      ( strTable )
		ENDIF
		SELECT      ( strTable )
		SET ORDER TO TAG ( strTag )
   CASE strAccess = [SQL]
		THIS.CreateCursor ( strTable )
ENDCASE
ENDPROC


PROCEDURE CreateCursor
PARAMETERS CurName
SELECT						;
  FieldName,				;
  FieldType,				;
  FieldLen,					;
  Decimals					;
 FROM DataDict				;
WHERE ALLTRIM(UPPER(CursorName)) == ALLTRIM(UPPER(CurName))	;
 INTO ARRAY CurDef

IF TYPE ( [CurDef(1)] ) = [U]
   Msg = [Programmer error:] + CHR(13)	;
   		+ CurName + [ fields not found in data dictionary]
   MESSAGEBOX( Msg, 64, _VFP.Caption )
   SUSPEND
ENDIF
 
DIMENSION CA ( ALEN(CurDef,1), 16 )
STORE [] TO CA
FOR I = 1 TO ALEN ( CA,1)
	CA(I,1) = ALLTRIM(CurDef(I,1))
	CA(I,2) = ALLTRIM(CurDef(I,2))
	CA(I,3) = CurDef(I,3)
	CA(I,4) = CurDef(I,4)
	CA(I,5) = .F.
	CA(I,6) = .F.
ENDFOR
CREATE Cursor &CurName FROM ARRAY CA
RELEASE CA, CurDef
IF USED ( [DataDict] )
   USE IN  DataDict
ENDIF
ENDPROC


PROCEDURE GetNextKey
PARAMETERS strMethod, strFldName
DO CASE
   CASE strMethod = [DBF]
		THIS.OpenFile ( [KeyFields] )
		LOCATE FOR KeyField = strFldName
		IF NOT FOUND()
		   APPEND BLANK
		   REPLACE KeyField WITH strFldName
		ENDIF
		REPLACE LastKey WITH LastKey + 1
		NewKey = TRANSFORM ( LastKey )
		USE IN KeyFields
		RETURN NewKey
   CASE strMethod = [SQL]
		Cmd	= [SELECT COUNT(*) FROM KeyFields ]	;
		+ [ WHERE KeyField ='] + strFldName + [']
		lr	= SQLEXEC ( THIS.Handle, Cmd )
		IF SQLResult.Exp = 0
		   Cmd	= [INSERT INTO KeyFields VALUES ('] + strFldName + [', 0)]
		   lr	= SQLEXEC ( THIS.Handle, Cmd )
		ENDIF
		Cmd	= [UPDATE KeyFields SET LastKey = LastKey + 1]	;
			+ [ WHERE KeyField ='] + strFldName + [']
		lr	= SQLEXEC ( THIS.Handle, Cmd )
		Cmd	= [SELECT LastKey FROM KeyFields ]	;
			+ [ WHERE KeyField = '] + strFldName + [']
		lr	= SQLEXEC ( THIS.Handle, Cmd )
		NewKey	= TRANSFORM ( SQLResult.LastKey )
		USE IN SQLResult
RETURN NewKey
ENDCASE
ENDPROC


PROCEDURE GetARecord
PARAMETERS strAccess, strTable, strKeyField, strKeyValue
DO CASE
   CASE strAccess = [SQL]
		Delim = IIF ( VARTYPE ( EVALUATE ( strKeyField ) ) = [C], ['], [] )
		Cmd = [SELECT * FROM ] + strTable	;
			+ [ WHERE ] + strKeyField + [ = ] + Delim + strKeyValue + Delim
		lr  = SQLEXEC( THIS.Handle, Cmd )
		SELECT ( strTable )
		ZAP
		APPEND FROM DBF([SQLResult])
		USE IN SQLResult
		RETURN [Ok]
   CASE strAccess = [DBF]
        IF VARTYPE( EVALUATE ( StrKeyField ) ) = [C]
           =SEEK (      strKeyValue,  strTable )
          ELSE
		   =SEEK (  VAL(strKeyValue), strTable )
		ENDIF
   CASE strAccess = [WWW]
		MESSAGEBOX( [Not yet coded], 64, _Screen.Caption, 1000 )
   CASE strAccess = [XML]
		MESSAGEBOX( [Not yet coded], 64, _Screen.Caption, 1000 )
ENDCASE
ENDPROC


PROCEDURE GetPrevRecord
PARAMETERS strAccess, strTable, strKeyField, strKeyValue ) 
DO CASE
   CASE strAccess = [SQL]
		Delim = IIF ( VARTYPE ( EVALUATE ( strKeyField ) ) = [C], ['], [] )
		Cmd = [SELECT TOP 1 * FROM ]  + strTable	;
			+ [ WHERE ] + strKeyField + [ < ] + Delim + strKeyValue + Delim	;
			+ [ ORDER BY ] + strKeyField + [ DESC]
		lr  = SQLEXEC( THIS.Handle, Cmd )
		IF RECCOUNT() > 0
		   SELECT ( strTable )
		   ZAP
		   APPEND FROM DBF([SQLResult])
		ENDIF
		USE IN SQLResult
		RETURN [Ok]
ENDCASE
ENDPROC


PROCEDURE GetNextRecord
PARAMETERS strAccess, strTable, strKeyField, strKeyValue ) 
DO CASE
   CASE strAccess = [SQL]
		Delim = IIF ( VARTYPE ( EVALUATE ( strKeyField ) ) = [C], ['], [] )
		Cmd = [SELECT TOP 1 * FROM ] + strTable	;
			+ [ WHERE ] + strKeyField + [ > ] + Delim + strKeyValue + Delim
		lr  = SQLEXEC( THIS.Handle, Cmd )
		IF RECCOUNT() > 0
		   SELECT ( strTable )
		   ZAP
		   APPEND FROM DBF([SQLResult])
		ENDIF
		USE IN SQLResult
		RETURN [Ok]
ENDCASE
ENDPROC


PROCEDURE GetAllRecords
PARAMETERS 				  strAccess, 	  strTable,		strCursor
THIS.GetFilteredRecords ( strAccess, [*], strTable, [], strCursor )
ENDPROC


PROCEDURE GetFilteredRecords
PARAMETERS strAccess, strFieldNames, strTable, WhereClause, strCursor
DO CASE
   CASE strAccess = [SQL]
		Cmd = [SELECT ] + strFieldNames + [ FROM ] + strTable + WhereClause
		lr  = SQLEXEC( THIS.Handle, Cmd, strCursor )
		IF lr < 0
		   MESSAGEBOX( "Command failed" )
		  ELSE
		   RETURN [Ok]
		ENDIF
   CASE strAccess = [DBF]
		Cmd = [SELECT ] + strFieldNames + [ FROM ] + strTable + WhereClause ;
			+ [ INTO CURSOR ] + strCursor + [ NOFILTER]
		&Cmd
   CASE strAccess = [WWW]
		MESSAGEBOX( [Not yet coded], 64, _Screen.Caption, 1000 )
   CASE strAccess = [XML]
		MESSAGEBOX( [Not yet coded], 64, _Screen.Caption, 1000 )
ENDCASE
ENDPROC


PROCEDURE DeleteFlatFileRecord 
PARAMETERS strMethod, strTable, strKeyField, strKeyValue
DO CASE
   CASE strMethod = [DBF]		&& don't have to do anything
   CASE strMethod = [SQL]
		Delim = IIF ( VARTYPE ( EVALUATE ( strKeyField ) ) = [C], ['], [] )
		cmd = [DELETE ] + strTable	;
			+ [ WHERE ] + strKeyField + [ = ] + Delim + strKeyValue + Delim
		SQLEXEC( THIS.Handle, Cmd )
   CASE strAccess = [WWW]
		MESSAGEBOX( [Not yet coded], 64, _Screen.Caption, 1000 )
   CASE strAccess = [XML]
		MESSAGEBOX( [Not yet coded], 64, _Screen.Caption, 1000 )
ENDCASE
ENDPROC

PROCEDURE SaveRemoteRecord
PARAMETERS lAdding, strAccess, strTable, strKeyField, strKeyValue
IF lAdding
   THIS.SendInsert ( strAccess, strTable, strKeyField )
  ELSE
   THIS.SendInsert ( strAccess, strTable, strKeyField, strKeyValue )
ENDIF
ENDPROC


PROCEDURE SendUpdate
PARAMETERS strAccess, strTableName, strKeyField, strKeyValue
DO CASE
   CASE strAccess = [SQL]
		Cmd = [UPDATE ] + StrTableName + [ SET ]
		FOR I = 1 TO FCOUNT()
			IF FIELD(I) = UPPER(StrKeyField)
			   LOOP
			ENDIF
			Fld = FIELD(I)
			Dta = ALLTRIM(TRANSFORM ( &Fld ))
			Dlm = IIF ( VARTYPE ( &Fld ) = [C], ['],	;
			      IIF ( VARTYPE ( &Fld ) = [D], ['],	;
			      IIF ( VARTYPE ( &Fld ) = [I], [],		;
			      IIF ( VARTYPE ( &Fld ) = [N], [],		;
			      IIF ( VARTYPE ( &Fld ) = [D], ['],	;
			      IIF ( VARTYPE ( &Fld ) = [M], ['],[]))))))
			Cmd = Cmd + Fld + [ = ] + Dlm + Dta + Dlm + [,]
		ENDFOR
		Delim = IIF ( VARTYPE ( EVALUATE ( strKeyField ) ) = [C], ['], [] )
		Cmd = LEFT ( Cmd, LEN(Cmd) -1 )	;
			+ [ WHERE ] + strKeyField + [ = ] + Delim + strKeyValue + Delim
*!*		MESSAGEBOX ( Cmd )		&& uncomment to see the command
		lr  = SQLEXEC ( THIS.Handle, Cmd )
ENDCASE
ENDPROC


PROCEDURE SendInsert
PARAMETERS strAccess, strTableName, strKeyField
DO CASE
   CASE strAccess = [SQL]
		Cmd = [INSERT ] + StrTableName + [ VALUES ( ]
		FOR I = 1 TO FCOUNT()
*!*	If your key field is an identity field, leave it out of the INSERT statement
*!*				IF FIELD(I) = UPPER(StrKeyField)
*!*				   LOOP
*!*				ENDIF
			Fld = FIELD(I)
			Dta = ALLTRIM(TRANSFORM ( &Fld ))
			Dlm = IIF ( VARTYPE ( &Fld ) = [C], ['],	;
			      IIF ( VARTYPE ( &Fld ) = [D], ['],	;
			      IIF ( VARTYPE ( &Fld ) = [I], [],		;
			      IIF ( VARTYPE ( &Fld ) = [N], [],		;
			      IIF ( VARTYPE ( &Fld ) = [D], ['],	;
			      IIF ( VARTYPE ( &Fld ) = [M], ['],[]))))))
			Cmd = Cmd + Dlm + Dta + Dlm + [,]
		ENDFOR
		* Remove excess comma and add right parenthesis
		Cmd = LEFT ( Cmd, LEN(Cmd) -1) + [ )]
		lr  = SQLEXEC ( THIS.Handle, Cmd )
   CASE strAccess = [WWW]
		MESSAGEBOX( [Not yet coded], 64, _Screen.Caption, 1000 )
   CASE strAccess = [XML]
		MESSAGEBOX( [Not yet coded], 64, _Screen.Caption, 1000 )
ENDCASE
ENDPROC


PROCEDURE GetUserID
PARAMETERS strAccess, strUserID, CursorName
IF NOT USED ( CursorName )
   RETURN [Error: Cursor "] + CursorName + [" not available]
ENDIF

DO CASE

   CASE strAccess = [WWW]

		lcBuffer = []
		lnBufLen = 0
		lr = oIP.HttpConnect ( THIS.IPAddress )
		IF lr < 0
		   MsgBox( UnableToConnect, 64, _VFP.Caption, 2000 )
		   RETURN [Error: Can't connect to data server]
		ENDIF
		cmd = THIS.Prefix + [GetUserID~] + strUserID
		lr = oIP.HTTPGetEx   ( cmd, @lcBuffer, @lnBufLen )
		IF lr < 0
		   MsgBox( UnableToConnect, 64, _VFP.Caption, 2000 )
		   RETURN [Error: Can't connect to data server]
		ENDIF
		oXML.XMLToCursor(ALLTRIM(lcBuffer))
		RETURN [Ok]

   CASE atrAccess = [SQL]

		Cmd = [SELECT UserID, Password, MenuName FROM USERS WHERE UserID = '] + strUserID + [']
		lr  = SQLEXEC( THIS.Handle, Cmd )
		SELECT ( CursorName )
		APPEND FROM DBF ( [SQLResult] )
		USE IN SQLResult
		RETURN [Ok]

   CASE strAccess = [WWW]
		MESSAGEBOX( [Not yet coded], 64, _Screen.Caption, 1000 )

   CASE strAccess = [XML]
		MESSAGEBOX( [Not yet coded], 64, _Screen.Caption, 1000 )

ENDCASE

ENDPROC


PROCEDURE CountRecs
PARAMETERS strTable
LOCAL lnNumRecs
DO CASE
   CASE DataAccess = [SQL]
		lr = SQLEXEC( THIS.Handle, [SELECT COUNT(*) AS NumRecs FROM ] + strTable )
		IF USED ( [SQLResult] )
		   lnNumRecs = SQLResult.NumRecs
		   USE
		  ELSE
		   lnNumRecs = 0
		ENDIF
   CASE strAccess = [WWW]
		MESSAGEBOX( [Not yet coded], 64, _Screen.Caption, 1000 )
   CASE strAccess = [XML]
		MESSAGEBOX( [Not yet coded], 64, _Screen.Caption, 1000 )
   OTHERWISE
		lnNumRecs = 0
ENDCASE
RETURN lnNumRecs
ENDPROC


PROCEDURE MakeSQLTable
PARAMETERS strTable
SaveAlias = ALIAS()
SELECT 0
USE ( strTable )
AFIELDS(Flds)
Tbl = ALIAS()
Cmd = ( [DROP TABLE ] + strTable )
lr  = SQLEXEC( THIS.Handle, Cmd  )
cmd = [CREATE TABLE ] + Tbl + [ ( ]
FOR I = 1 TO ALEN(Flds,1)
	Fld = Flds(I,1)
	Typ = Flds(I,2)
	DO CASE
	   CASE Typ = [C]
			Typ = [Char(] + TRANSFORM(Flds(I,3))+[) NOT NULL DEFAULT '']
	   CASE Typ $ [DT]
			Typ = [DateTime NOT NULL DEFAULT '']
	   CASE Typ = [I]
			Typ = [Integer NOT NULL DEFAULT 0]
	   CASE Typ = [N]
			Typ = [Numeric(] + TRANSFORM(Flds(I,3)) + [,] + TRANSFORM(Flds(I,4)) + [) NOT NULL DEFAULT 0]
	   CASE Typ = [L]
			Typ = [Bit NOT NULL DEFAULT 0]
		   CASE Typ = [M]
				Typ = [Text NOT NULL DEFAULT '']
	ENDCASE
	Cmd = Cmd + Fld + [ ] + Typ + [, ] + CHR(13)
ENDFOR
Cmd = LEFT(Cmd,LEN(Cmd)-3) + [ )]
USE
IF NOT EMPTY ( SaveAlias )
   SELECT    ( SaveAlias )
ENDIF
lr = SQLEXEC( THIS.Handle, Cmd )
ENDPROC


PROCEDURE LoadSQLTable
PARAMETERS strTable
SaveAlias = ALIAS()
SELECT 0
USE ( strTable )
WAIT WINDOW [Loading table ] + strTable NOWAIT
AFIELDS(Flds)
Tbl = ALIAS()
SCAN
	WAIT WINDOW [Loading record ] + TRANSFORM(RECNO()) NOWAIT
 	Cmd = [INSERT INTO ] + Tbl + [ VALUES ( ]
	FOR I = 1 TO ALEN(Flds,1)
		Fld = Flds(I,1)
		Typ = Flds(I,2)
		DO CASE
		   CASE Typ = [C]
				Dta = ['] + TRANSFORM(&Fld) + [']
		   CASE Typ $ [DT]
				Dta = ['] + TRANSFORM(&Fld) + [']
		   CASE Typ = [I]
				Dta =       TRANSFORM(&Fld)
		   CASE Typ = [N]
		   		Ln  = TRANSFORM(Flds(I,3))
		   		Dc  = TRANSFORM(Flds(I,4))
				Dta = STR(&Fld,&Ln,&Dc)
		   CASE Typ = [L]
				Dta = IIF(&Fld,[0],[1])
		ENDCASE
		Cmd = Cmd + Dta + [,]
	ENDFOR
	Cmd = LEFT(Cmd,LEN(Cmd)-1) + [ )]
	lr = SQLEXEC( THIS.Handle, Cmd )
ENDSCAN
USE
IF NOT EMPTY ( SaveAlias )
   SELECT    ( SaveAlias )
ENDIF
ENDPROC


PROCEDURE Download
PARAMETERS strAccess, strTable
strTable = ALLTRIM(strTable)

DO CASE

   CASE strAccess = [SQL]
		Cmd = [SELECT * FROM ] + strTable
		lr  = SQLEXEC( THIS.Handle, Cmd )
		SELECT 0
		USE ( strTable )
		ZAP
		APPEND FROM DBF([SQLResult])
		MESSAGEBOX( TRANSFORM(_Tally) + [ records downloaded], 64, _VFP.Caption, 500 )
		USE
		USE IN SQLResult
		RETURN [Ok]

   CASE strAccess = [WWW]

		lcBuffer = []
		lnBufLen = 0
		UnableToConnect = [Unable to connect to the web server]
		lr = oIP.HttpConnect ( THIS.IPAddress )
		IF lr < 0
		   MessageBox( UnableToConnect, 64, _VFP.Caption, 2000 )
		   RETURN [Error: Can't connect to data server]
		ENDIF
		cmd = THIS.Prefix + [GetTable~] + strTable
		lr = oIP.HTTPGetEx   ( cmd, @lcBuffer, @lnBufLen )
		IF lr < 0
		   MessageBox( UnableToConnect, 64, _VFP.Caption, 2000 )
		   RETURN [Error: Can't connect to data server]
		ENDIF
		SELECT ( strTable )
		ZAP
		oXML.XMLToCursor(ALLTRIM(lcBuffer))
		RETURN [Ok]


   CASE strAccess = [XML]
		MESSAGEBOX( [Not yet coded], 64, _Screen.Caption, 1000 )

ENDCASE

ENDPROC

ENDDEFINE