* ERRTRAP
PARAMETERS ProgName, LineNum, ErrNum, Msg, Code
* Called with: ON ERROR DO ERRTRAP WITH PROGRAM(), LINENO(), ERROR(), MESSAGE(), MESSAGE(1)

ON ERROR

SaveAlias = ALIAS()
SaveDB = SET("DATABASE")
SET DATABASE TO
SET MEMOWIDTH TO 80

IF NOT FILE ( "ERRORS.DBF" )
   CREATE TABLE ERRORS FREE ;
   ( Date D(8), TIME C(5), Program C(50), LineNumber N(5), ErrorNum N(4), Message C(240), BadCode C(240) )
ENDIF
IF NOT USED ( "ERRORS" )
   SELECT 0
   USE ERRORS
ENDIF

INSERT INTO ERRORS VALUES ( DATE(), TIME(), m.ProgName, m.LineNum, m.ErrNum, m.Msg, m.Code )

IF NOT EMPTY ( SaveAlias )
   SELECT	 ( SaveAlias )
ENDIF

SET MEMOWIDTH TO 90

* In case the message is too long, break out the first two lines
Msg1  = MLINE ( Msg,  1 )
Msg2  = MLINE ( Msg,  2 )

Code1 = MLINE ( m.Code, 1 )
Code2 = MLINE ( m.Code, 2 )
Code3 = MLINE ( m.Code, 3 )
Code4 = MLINE ( m.Code, 4 )

* Poor man's MessageBox with three valid choices:
msg = [Error in ] + ProgName + " at line " + ALLTRIM(STR(LineNum)) + CHR(13) ;
 + Msg1						+ CHR(13) ;
 + Msg2						+ CHR(13) ;
 + "Code was :"				+ CHR(13) ;
 + Code1					+ CHR(13) ;
 + Code2					+ CHR(13) ;
 + Code3					+ CHR(13) ;
 + Code4

=MessageBox ( msg, 64, _VFP.Caption )

WAIT WINDOW "<C>ancel, <R>esume, <D>ebug: "	TO Result

DO CASE
   CASE Result $ [Cc]
   		CLEAR EVENTS
   		SET SYSMENU TO DEFAULT
		* Clear open transactions
   		DO WHILE TXNLEVEL() > 0
   		   ROLLBACK
   		ENDDO
   		* Restore buffered changes
   		IF CursorGetProp("Buffering") = 3
	       IF "2" $ GetFldState(-1)		&& At least one field's contents was changed
		      =TableRevert(.T.)
		   ENDIF
		ENDIF
		FOR I = 1 TO _Screen.ControlCount
			_Screen.RemoveObject ( _Screen.Controls[1].Name )
		ENDFOR
   		CLEAR WINDOW
		CLOSE ALL
		CLEAR
		CANCEL
   CASE Result $ [Dd]
   		SET SYSMENU TO DEFAULT
		IF NOT EMPTY ( SaveDB )
		   SET DATABASE TO ( SaveDB )
		ENDIF
   		ACTIVATE WINDOW DEBUG
   		SET STEP ON
   OTHERWISE		&& default to "Resume"
		IF NOT EMPTY ( SaveDB )
		   SET DATABASE TO &SaveDB
		ENDIF
		ON ERROR DO ERRTRAP WITH PROGRAM(), LINENO(), ERROR(), MESSAGE(), MESSAGE(1)
ENDCASE
