DEFINE CLASS WebClass AS SESSION OLEPUBLIC

FilePrefix = SYS(5) + CURDIR()
ConnString = [Driver={SQL Server"};server=(local);database=MyNorthwind;UID=sa;PWD=;]


PROCEDURE Init
SET PATH TO ( FilePrefix )
SET TALK OFF
SET STRICTDATE TO 0
ENDPROC

*(1)
FUNCTION GetStructure ( pcAccess AS String, pcTable AS String ) AS String
SET TALK OFF
LOCAL oXML AS XMLAdapter
oXML = CREATEOBJECT ( [XMLAdapter] )
cStru = []
DO CASE
   CASE pcAccess = [DBF]
        USE ( pcTable )
        COPY STRUCTURE EXTENDED TO C1
        USE C1
        oXML.AddTableSchema ( "C1" )
        oXML.ToXML( cStru )
        USE
        ERASE C1.DBF
   CASE pcAccess = [SQL]
        Handle = SQLSTRINGCONNECT(THIS.Connstring)
        IF Handle > 0
           Cmd = [SELECT * FROM ] + pcTable + [ WHERE 1=2]
           lr = SQLEXEC( Handle, Cmd )
           IF lr > 0 Then
              COPY STRUCTURE EXTENDED TO C1
              USE C1
	          LOCAL oXML AS XMLAdapter
	          oXML = CREATEOBJECT ( [XMLAdapter] )
	          oXML.AddTableSchema ( "C1" )
	          oXML.ToXML( cStru )
	          USE
              ERASE C1.DBF
           ENDIF
           SQLDISCONNECT(0)
        ENDIF
ENDCASE
RELEASE oXML
RETURN  cStru
ENDFUNC


*(2)
FUNCTION GetMatchingRecords ( pcAccess AS String, lcCmd AS String, pcTable AS String ) AS String
SET TALK OFF
DO CASE
   CASE pcAccess = [DBF]
        lcCmd = lcCmd + [ INTO CURSOR C1]
        &lcCmd   && Results are now in cursor C1
        LOCAL oXML AS XMLAdapter
        oXML = CREATEOBJECT ( [XMLAdapter] )
        oXML.AddTableSchema ( "C1" )
        oXML.ToXML( cStru )
        IF USED   ( pcTable )
           USE IN ( pcTable )
        ENDIF
        RETURN cStru
ENDCASE
ENDFUNC


*(3)
FUNCTION GetOneRecord ( pcAccess AS String, pcTable AS String, pcKeyField AS String, PCKeyValue AS String ) AS String
SET TALK OFF
DO CASE
   CASE pcAccess = [DBF]
         SELECT 0
         USE ( pcTable )
         Dlm = IIF ( TYPE(lcKeyField ) $ [CM], ['], [] )  && Either string or numeric
         lcCmd      = [SELECT * FROM ] + pcTable + [ WHERE ] + lcKeyField + [=] + Dlm + lcKeyValue + Dlm
         lcCmd = lcCmd + [ INTO CURSOR C1]
        &lcCmd   && Results are now in cursor C1
         LOCAL oXML AS XMLAdapter
         oXML = CREATEOBJECT ( [XMLAdapter] )
         oXML.AddTableSchema ( "C1" )
         oXML.ToXML( cStru )
         USE
         IF USED   ( pcTable )
            USE IN ( pcTable )
         ENDIF
         RETURN cStru
ENDCASE
ENDFUNC


*(4)
PROCEDURE InsertOrUpdateRecord ( pcAccess AS String, pcCmd AS String, pcTable AS String ) AS String
SET TALK OFF
DO CASE
   CASE pcAccess = [DBF]
        &lcCmd
        IF USED   ( pcTable )
           USE IN ( pcTable )
        ENDIF
   CASE pcAccess = [SQL]
        Handle = SQLSTRINGCONNECT(THIS.Connstring)
        IF Handle > 0
           lr = SQLEXEC( Handle, lcCmd )
           IF lr <= 0 Then
              lcResult = [Error: SQL UPDATE/INSERT error]
             ELSE
              lcResult = [Ok]
           ENDIF
          ELSE
              lcResult = [Error: SQL connection error]
        ENDIF
ENDCASE
ENDPROC


*(5)
PROCEDURE GetNextKeyValue ( pcAccess AS String, pcTable AS String ) AS String
SET TALK OFF
EXTERNAL ARRAY laVal
DO CASE

   CASE pcAccess = [DBF]
        IF NOT FILE ( [Keys.DBF] )
           CREATE TABLE Keys ( TableName Char(20), LastKeyVal Integer )
        ENDIF
        IF NOT USED ( [Keys] )
           USE Keys IN 0
        ENDIF
        SELECT Keys
        LOCATE FOR TableName = pcTable
        IF NOT FOUND()
           INSERT INTO Keys VALUES ( pcTable, 0 )
        ENDIF
        Cmd = [UPDATE Keys SET LastKeyVal=LastKeyVal + 1 ]    ;
            + [ WHERE TableName='] + pcTable + [']
        &Cmd
        Cmd = [SELECT LastKeyVal FROM Keys WHERE TableName = '] ;
            + pcTable + [' INTO ARRAY laVal]
        &Cmd
        USE IN Keys
        lcResult = TRANSFORM(laVal(1))
        RETURN lcResult	&& convert to XML?

   CASE pcAccess = [SQL]

        Cmd = [SELECT Name FROM SysObjects WHERE Name='KEYS' AND Type='U']
        lr = SQLEXEC( THIS.Handle, Cmd )
        IF lr < 0
           lcResult = [Error: ] + CHR(13) + Cmd
           IF lcResult = [Error]
              RETURN lcResult
           ENDIF
        ENDIF

        IF RECCOUNT([SQLResult]) = 0
           Cmd = [CREATE TABLE Keys ( TableName Char(20), LastKeyVal Integer )]
           lr = SQLEXEC( THIS.Handle, Cmd )
           IF lr < 0
              lcResult = [Error: ] + CHR(13) + Cmd
           ENDIF
           IF lcResult = [Error]
              RETURN lcResult
           ENDIF
        ENDIF

        Cmd = [SELECT LastKeyVal FROM Keys WHERE TableName='] + pcTable + [']
        lr = SQLEXEC( THIS.Handle, Cmd )
        IF lr < 0
           IF lr < 0
              lcResult = [Error: ] + CHR(13) + Cmd
           ENDIF
           IF lcResult = [Error]
              RETURN lcResult
           ENDIF
        ENDIF

        IF RECCOUNT([SQLResult]) = 0
           Cmd = [INSERT INTO Keys VALUES ('] +  pcTable + [', 0 )]
           lr = SQLEXEC( THIS.Handle, Cmd )
           IF lr < 0
              IF lr < 0
                 lcResult = [Error: ] + CHR(13) + Cmd
              ENDIF
              IF lcResult = [Error]
                 RETURN lcResult
              ENDIF
           ENDIF
        ENDIF

        Cmd = [UPDATE Keys SET LastKeyVal=LastKeyVal + 1 WHERE TableName='] +  pcTable + [']
        lr = SQLEXEC( THIS.Handle, Cmd )
        IF lr < 0
           IF lr < 0
              lcResult = [Error: ] + CHR(13) + Cmd
           ENDIF
           IF lcResult = [Error]
              RETURN lcResult
           ENDIF
        ENDIF

        Cmd = [SELECT LastKeyVal FROM Keys WHERE TableName='] +  pcTable + [']
        lr = SQLEXEC( THIS.Handle, Cmd )
        IF lr < 0
           IF lr < 0
              lcResult = [Error: ] + CHR(13) + Cmd
           ENDIF
           IF lcResult = [Error]
              RETURN lcResult
           ENDIF
        ENDIF

        lcResult = TRANSFORM(SQLResult.LastKeyVal)
        USE IN SQLResult
        RETURN lcResult

ENDCASE
ENDPROC


*(6)
PROCEDURE DeleteRecord ( ;
 pcAccess   AS String, 	 ;
 pcTable    AS String,   ;
 pcKeyField AS String,   ;
 pcKeyValue AS String,   ;
 pcDelim    AS String    ) AS String
SET TALK OFF
lcCmd      = [DELETE FROM ] + pcTable 		;
		   + [ WHERE ] + pcKeyField + [=]	;
		   + pcDelim   + pcKeyValue + pcDelim
DO CASE
   CASE pcAccess = [DBF]
        &lcCmd
        IF USED   ( pcTable )
           USE IN ( pcTable )
        ENDIF
        lcResult = [Ok]
   CASE pcAccess = [SQL]
        Handle = SQLSTRINGCONNECT(THIS.Connstring)
        IF Handle > 0
           lr = SQLEXEC( Handle, lcCmd )
           IF lr <= 0 Then
              lcResult = [Error: SQL DELETE error]
             ELSE
              lcResult = [Ok]
           ENDIF
          ELSE
              lcResult = [Error: SQL connection error]
        ENDIF
ENDCASE
RETURN lcResult
ENDPROC


ENDDEFINE