* Program-ID....: Convert.prg
* Purpose.......: Convert application tables to new format and apply cleanup changes

CLOSE ALL
SET EXCLUSIVE ON
SET STRICTDATE TO 0
SET STATUS BAR ON
SET TALK ON
SET SAFETY OFF
SET CPDIALOG OFF

StartTime = TIME()

ON KEY LABEL F1 *

PUBLIC oDataMgr
oDataMgr = NEWOBJECT ( "DATAMGR", "DATAMGR.PRG" )
USE CONTROL
FOR I = 1 TO FCOUNT()
	Fld = FIELD(I)
	PUBLIC &Fld
ENDFOR
SCATTER MEMVAR
USE
ConnString = ALLTRIM(m.ConnString)

PUBLIC Supervisor AS Integer
PUBLIC DataAccess AS String

Supervisor = 1
DataAccess = [SQL]

=SQLDISCONNECT(0)

* Always uses the (LOCAL) server, so don't use what's in CONTROL.DBF
ConnString = [Driver={SQL Server};Server=(local);Database=UserDatabase;Uid=Les;Pwd=pinter;]
oDataMgr.Handle = SQLStringConnect ( m.ConnString )  && from CONTROL.DBF

IF oDataMgr.Handle < 1
   MessageBox ( [Couldn't connect to SQL Server] + CHR(13)	;
	 + [Connection string: ] + CHR(13) + ConnString,		;
	   64, _VFP.Caption )
ENDIF

lcPath = [\\UserComputer\c-drive\userdir\]
lcPath = GETDIR([Where are the original tables?])
IF EMPTY ( lcPath )
   RETURN
ENDIF

lcPath = ADDBS ( lcPath )
_VFP.Caption = [Migrating data from ] + lcPath

*(1) Remove old LastKey entries
SELECT 99
USE KEYFIELDS
ZAP

*(2) Remote duplicate cases and create MOVES.DBF
MakeMove()
CLOSE TABLES

*(3) Remote duplicate MEMBERS
USE MEMBERS
ZAP
APPEND FROM ( lcPath + [MEMBER] )

GO TOP
REPLACE ALL KEYVALUE WITH RECNO()
GO BOTTOM
INSERT INTO KEYFIELDS VALUES ( [MEMBERS], MEMBERS.KeyValue )

* Remove duplicates in the MEMBERS table
SELECT			;
  AlienNum, 		;
  COUNT(*)			;
  FROM MEMBERS 		;
 HAVING COUNT(*) > 1	;
 GROUP BY AlienNum	;
 ORDER BY 2 DESC		;
 INTO ARRAY laAliens

FOR I = 1 TO ALEN ( laAliens, 1 )
	IF VAL(laAliens(I,1)) = 0
	   LOOP
	ENDIF
	GO TOP
	LOCATE FOR AlienNum = laAliens(I,1)
	FOR J = 1 TO laAliens(I,2) - 1
		CONTINUE
		DELETE NEXT 1
	ENDFOR
ENDFOR

*(4) Convert tables that added a KeyValue field:
USE TABLIST
FldList = [,FOLLOWUP,MAXCASH,MEMBERLI,MOVES,PREMIUM,STATUS,UPGRADE]
SCAN FOR ( [,] + TRIM(TableName) + [,] ) $ FldList

	 lcFile = TRIM(TableName)
	 SELECT 0
	 USE ( lcFile )
* Don't change MOVES, which is a new file.
	 IF lcFile <> [MOVES]
		 ZAP
		 lcOldFile = lcFile
* Deal with tables whose names have changed here
		 IF lcFile    = [CONTACTS]
		    lcOldFile = [CONTACT]
		 ENDIF
		 APPEND FROM ( lcPath + lcOldFile )
		 GO TOP
	 ENDIF
* Add key field values here
	 REPLACE ALL KEYVALUE WITH RECNO()
	 GO BOTTOM
	 INSERT INTO KEYFIELDS VALUES ( lcFile, EVAL(lcFile + [.KeyValue]) )
	 GO TOP
* Change all check number to seven digits with leading zeroes
	 IF ( [,] + lcFile + [,] ) $ [CHECKS,PAYMENTS,]
		REPLACE ALL CHECKNUM WITH TRANSFORM ( VAL(CHECKNUM), [@L #######] )
	 ENDIF
	 USE
ENDSCAN

USE ESL
REPLACE ALL ;
 Class		WITH STRTRAN(Class,'computer lab','Computer Lab'),	;
 Class		WITH STRTRAN(Class,'level ii','Level II',-1,-1,1),	;
 Class		WITH STRTRAN(Class,'level i', 'Level I',-1,-1,1),	;
 Class		WITH STRTRAN(Class,'AM','am'),	;
 Class		WITH STRTRAN(Class,'PM','pm')
USE

*(6) Convert tables with no KeyValue field that changed their name
USE GRANTS
ZAP
APPEND FROM ( lcPath + [GRANT] )
USE

*(7) Convert tables that required a field name change
*    because a reserved word was used as a field name.
USE ALLOCATE
ZAP
SELECT 0
CREATE CURSOR CarryAll ( Allocate Char(4), CALLOCATE Char(4), Descrip Char(25) )
APPEND FROM x && ( lcPath +    [Allocate] )
REPLACE ALL CALLOCATE WITH ALLOCATE
SELECT ALLOCATE
APPEND FROM DBF([CarryAll])
USE IN CarryAll
USE

*(8) Convert all other tables
USE TABLIST
ExcludedList = [,NOTES,MOVES,MEMBERS,CASES,ESL,PREMIUM,STATUS,UPGRADE,]

SCAN FOR NOT ( [,] + ALLTRIM(UPPER(TableName)) + [,] ) $ ExcludedList
             *****************************************
	SELECT 0
	USE ( ALLTRIM(TABLIST.TableName) )
	ZAP
	APPEND FROM ( lcPath + ALLTRIM(TABLIST.TableName) )
	USE
	SELECT TABLIST
ENDSCAN
USE

*(9) Fix all data previously corrected by users
SELECT DISTINCT TableName	;
  FROM CHANGES			;
  INTO ARRAY FixerUppers 	;
 ORDER BY TableName

FOR EACH TName IN FixerUppers
	SELECT * FROM Changes WHERE TableName = TName INTO ARRAY laChanges
	SELECT 5
	USE ( TName )
	FOR I = 1 TO  ALEN ( laChanges, 1 )
		F	= laChanges[I,2]
		D	= VARTYPE  ( F )
		O	= ALLTRIM(laChanges[I,3])
		N	= ALLTRIM(laChanges[I,4])
		L   = []
		R   = []
		Cmd	= [UPDATE ] + TName + [ SET ] + F + [ = ] + L + N + R ;
			+ [ WHERE ]				+ F + [ = ] + L + O + R
		WAIT WINDOW Cmd NOWAIT
		&Cmd
	ENDFOR
ENDFOR
WAIT CLEAR

*(10) Upload all tables to SQL
USE TABLIST
ExcludedList = [,NOTES,FOXUSER,TABLIST,USERS,]
SCAN FOR NOT ( [,] + UPPER(TableName) + [,] ) $ ExcludedList
	 Tbl = ALLTRIM(TABLIST.TableName)
	 oDataMgr.CloseIfOpen  ( Tbl )
	 oDataMgr.MakeSQLTable ( Tbl )
	 oDataMgr.Upload	     ( Tbl )
ENDSCAN

oDataMgr.CloseIfOpen  ( [KeyFields] )
oDataMgr.MakeSQLTable ( [KeyFields] )
oDataMgr.Upload		 ( [KeyFields] )

*(11) Create ESLCLASS table, which doesn't exist in old system
SQLEXEC ( oDataMgr.Handle, [DROP TABLE ESLCLASS] )
SQLEXEC ( oDataMgr.Handle, [CREATE TABLE ESLCLASS ( Class Character(15) )] )

SQLEXEC ( oDataMgr.Handle, [INSERT INTO ESLCLASS VALUES ( 'Computer Lab   ')])
SQLEXEC ( oDataMgr.Handle, [INSERT INTO ESLCLASS VALUES ( 'Level I 11:15am')])
SQLEXEC ( oDataMgr.Handle, [INSERT INTO ESLCLASS VALUES ( 'Level I 2:00pm ')])
SQLEXEC ( oDataMgr.Handle, [INSERT INTO ESLCLASS VALUES ( 'Level I 6:00pm ')])
SQLEXEC ( oDataMgr.Handle, [INSERT INTO ESLCLASS VALUES ( 'Level I 8:30am ')])
SQLEXEC ( oDataMgr.Handle, [INSERT INTO ESLCLASS VALUES ( 'Level II 6:00pm')])

* Final data cleanup...
Cmd = [DELETE MEMBERS WHERE CaseNum NOT IN ( SELECT CaseNum FROM Cases )]
lr = SQLEXEC ( oDataMgr.Handle, Cmd )
IF lr < 0
   MESSAGEBOX( [SQL command failed:] + CHR(13) + Cmd, 16 )
ENDIF

* Remove records containing fatal data errors that old system couldn't delete
Cmd = [DELETE MEMBERS WHERE KeyValue IN ( 123,6110,6189,6298,594,4896,4364,3457,3455,3456,4590,4950,5422,6199 )]
lr = SQLEXEC ( oDataMgr.Handle, Cmd )
IF lr < 0
   MESSAGEBOX( [SQL command failed:] + CHR(13) + Cmd, 16 )
ENDIF

* Create a key value for records that contained a blank value in a required field 
* in cases where we couldn't reconstruct the correct value, but don't want to discard the data
Cmd = [UPDATE MEMBERS SET AlienNum = LEFT(Last,4) + LEFT(First,4) ;
      WHERE KeyValue IN ( 314,323,1141,2160,2164,2326,2446,2571,2835,2890,3585,2284,546)]
lr = SQLEXEC ( oDataMgr.Handle, Cmd )
IF lr < 0
   MESSAGEBOX( [SQL command failed:] + CHR(13) + Cmd, 16 )
ENDIF

* Throw away orphans if all attempts to build a relation have failed:
Cmd = [DELETE ESL WHERE aliennum NOT IN ( SELECT aliennum FROM members )]
lr = SQLEXEC ( oDataMgr.Handle, Cmd )
IF lr < 0
   MESSAGEBOX( [SQL command failed:] + CHR(13) + Cmd, 16 )
ENDIF

* Remove ESL records with blank case numbers
Cmd = [DELETE ESL WHERE casenum = '          ']
lr = SQLEXEC ( oDataMgr.Handle, Cmd )
IF lr < 0
   MESSAGEBOX( [SQL command failed:] + CHR(13) + Cmd, 16 )
ENDIF

WAIT CLEAR
Took = [ Took ] + TRANSFORM ( TIME() - StartTime ) + [ seconds]

MESSAGEBOX( [Ta-da!] + CHR(13) + Took, 64, [Done] )

SET TALK OFF
SET STATUS BAR OFF