DEFINE CLASS DataMgr AS Relation

Access	  = [SQL]
UserID	  = []
IPAddress = [localhost]
Prefix    = [/wconnect/wc.dll?IPDataMgr~]
Handle	  = 0

* This property determines whether we use WebConnection XML parser, VFP XML Parser, or no XML at all.
XMLType	  = [ZIP]	&& OR VFP OR WC


FUNCTION  GetUsrPwdMenu
PARAMETERS strAccess

DO CASE

   CASE strAccess = [SQL]

		cmd = [SELECT UserID, Password, MenuName, Supervisor FROM USERS ORDER BY UserID]
		lr  = SQLEXEC( THIS.Handle, Cmd, [UserInfo] )
		SELECT Users
		ZAP
		APPEND FROM DBF ( [UserInfo] )
		USE IN UserInfo
		RETURN [Ok]

   CASE strAccess = [WWW]

		lcBuffer = []
		lnBufLen = 0
		lr = oIP.HttpConnect ( THIS.IPAddress )
		IF lr < 0
		   RETURN [Error: Can't connect to data server]
		ENDIF
		cmd = THIS.Prefix + [GetUsers]
		lr = oIP.HTTPGetEx ( cmd, @lcBuffer, @lnBufLen )
		IF lr < 0
		   RETURN [Error: Command failed: ] + cmd
		ENDIF
		SELECT Users
		ZAP
		THIS.Transport  ( lcBuffer, [Users] )
		GO TOP
		RETURN [Ok]

ENDCASE
ENDFUNC


PROCEDURE Transport
PARAMETERS  strXML, strAlias, NotNeeded
SELECT ( strAlias )
DO CASE
   CASE THIS.XMLType = [WC]
		oXML.XMLToCursor( strXML )
   CASE THIS.XMLType = [VFP]
		XMLTOCURSOR ( strXML, strAlias )
   CASE THIS.XMLType = [ZIP]
   		ExtLoc				= AT ( [.DBF], strXML )
   		FName				= SUBSTR( strXML, ExtLoc - 8,  8 )
   		FName				= ALLTRIM(CHRTRAN(FName,CHR(0),CHR(32)))
   		FullDir				= SYS(5) + CURDIR()
   		ZipFileName			= FullDir + FName + [.ZIP]
   		STRTOFILE ( strXML, ZipFileName )
   		UNZIP.Destination	= FullDir
   		UNZIP.ZipFile   	= ZipFileName

   		UNZIP.FileSpec		= [*.DBF]
		UNZIP.ActionDZ		= 8		&& UNZIP_EXTRACT

		UNZIP.QuietFlag		= .T.
   		UNZIP.FileSpec		= [*.FPT]
		UNZIP.ActionDZ		= 8		&& UNZIP_EXTRACT
		UNZIP.QuietFlag		= .F.
		ZAP
		APPEND FROM ( FName )
		 cmd = [DELETE FILE ] + FName + [.ZIP]
		&cmd
		 cmd = [DELETE FILE ] + FName + [.DBF]
		&cmd
		IF FILE ( FName + [.FPT] )
			 cmd = [DELETE FILE ] + FName + [.FPT]
			&cmd
		ENDIF
ENDCASE
GO TOP
ENDPROC


PROCEDURE Synchronize
PARAMETERS strTabName

strTabName = ALLTRIM(strTabName)

DO CASE

   CASE THIS.Access = [SQL]

		cmd = [SELECT * FROM ] + strTabName
		lr  = SQLEXEC( THIS.Handle, cmd, [SQLData] )

		SELECT 0
		USE ( strTabName )
		ZAP
		APPEND FROM DBF([SQLData])
		WAIT WINDOW TRANSFORM(_Tally) + [ records downloaded] TIMEOUT 1
		USE
		USE IN SQLData
		RETURN [Ok]

   CASE THIS.Access = [WWW]

		lcBuffer = []
		lnBufLen = 0
		lr = oIP.HttpConnect ( THIS.IPAddress )
		IF lr < 0
		   MessageBox( UnableToConnect, 64, _VFP.Caption, 2000 )
		   RETURN [Error: Can't connect to data server]
		ENDIF
		cmd = THIS.Prefix + [GetTable~] + strTabName
		lr = oIP.HTTPGetEx   ( cmd, @lcBuffer, @lnBufLen )
		IF lr < 0
		   MessageBox( UnableToConnect, 64, _VFP.Caption, 2000 )
		   RETURN [Error: Can't connect to data server]
		ENDIF
		SELECT ( strTabName )
		ZAP
		MESSAGEBOX( lcBuffer )
		THIS.Transport ( lcBuffer, strTabName, THIS.Access )
		RETURN [Ok]

   OTHERWISE

	RETURN [Unknown data access type: ] + THIS.Access

ENDCASE

ENDPROC


PROCEDURE CloseIfOpen
PARAMETERS  strAlias

IF USED   ( strAlias )
   USE IN ( strAlias )
ENDIF
ENDPROC


PROCEDURE  OpenDBF
PARAMETERS strTable, IndexTag

IF NOT USED	( strTable )
   SELECT 0
USE 		( strTable )
ENDIF
SELECT		( strTable )
IF NOT EMPTY		( IndexTag  )
   SET ORDER TO TAG ( IndexTag )
ENDIF
ENDPROC


PROCEDURE GetAccess
PARAMETERS strTable

IF DataAccess = [DBF]
   RETURN [DBF]
ENDIF
PrevAlias = ALIAS()
THIS.OpenDBF ( [TabList] )
LOCATE FOR UPPER(TableName) = UPPER(strTable)
IF NOT FOUND()
   MESSAGEBOX( [No entry in TABLIST.DBF for ] + strTable, 64, _Screen.Caption, 5000 )
   SET SYSMENU TO DEFAULT
   CANCEL
ENDIF
strAccess = ALLTRIM ( TabList.Access )
USE
IF NOT EMPTY ( PrevAlias )
   SELECT    ( PrevAlias )
ENDIF
RETURN strAccess
ENDPROC


PROCEDURE UseDBFOrCursor
PARAMETERS strAccess, strTable, strTag

DO CASE
   CASE strAccess = [DBF]
		IF NOT USED ( strTable )
		   SELECT 0
		   USE      ( strTable )
		ENDIF
		SELECT      ( strTable )
		IF NOT EMPTY (strTag   )
		   SET ORDER TO TAG ( strTag )
		ENDIF
   CASE strAccess = [SQL]
		IF NOT USED ( strTable )
		   THIS.CreateCursor ( strTable )
		ENDIF
		SELECT      ( strTable )
   CASE strAccess = [WWW]
		IF NOT USED ( strTable )
		   THIS.CreateCursor ( strTable )
		ENDIF
		SELECT      ( strTable )
ENDCASE
ENDPROC


PROCEDURE UseCursor
PARAMETERS strAccess, strTable

CursorName = IIF ( DataAccess = [DBF], strTable + [DBF], strTable )
IF NOT USED ( strTable )
   SELECT 0
   USE      ( CursorName ) ALIAS ( strTable )
ENDIF
SELECT      ( strTable )
ENDPROC


PROCEDURE CreateView
PARAMETERS strTableName

SELECT						;
  FieldName,				;
  FieldType,				;
  FieldLen,					;
  Decimals					;
 FROM DataDict				;
WHERE ALLTRIM(UPPER(CursorName)) == ALLTRIM(UPPER(strTableName))	;
 INTO ARRAY CurDef

IF TYPE ( [CurDef(1)] ) = [U]
   Msg = [Programmer error:] + CHR(13)	;
   		+ strTableName + [ fields not found in data dictionary]
   MESSAGEBOX( Msg, 64, _VFP.Caption )
   SUSPEND
ENDIF
 
DIMENSION CA ( ALEN(CurDef,1), 16 )
STORE [] TO CA
FOR I = 1 TO ALEN ( CA,1)
	CA(I,1) = ALLTRIM(CurDef(I,1))
	CA(I,2) = ALLTRIM(CurDef(I,2))
	CA(I,3) = CurDef(I,3)
	CA(I,4) = CurDef(I,4)
	CA(I,5) = .F.
	CA(I,6) = .F.
ENDFOR
CREATE Cursor View&strTableName. FROM ARRAY CA
RELEASE CA, CurDef
IF USED ( [DataDict] )
   USE IN  DataDict
ENDIF
ENDPROC


PROCEDURE CreateCursor
PARAMETERS CurName

SELECT						;
  FieldName,				;
  FieldType,				;
  FieldLen,					;
  Decimals					;
 FROM DataDict				;
WHERE ALLTRIM(UPPER(CursorName)) == ALLTRIM(UPPER(CurName))	;
 INTO ARRAY CurDef

IF TYPE ( [CurDef(1)] ) = [U]
   Msg = [Programmer error:] + CHR(13)	;
   		+ CurName + [ fields not found in data dictionary]
   MESSAGEBOX( Msg, 64, _VFP.Caption )
   SUSPEND
ENDIF
 
DIMENSION CA ( ALEN(CurDef,1), 16 )
STORE [] TO CA
FOR I = 1 TO ALEN ( CA,1)
	CA(I,1) = ALLTRIM(CurDef(I,1))
	CA(I,2) = ALLTRIM(CurDef(I,2))
	CA(I,3) = CurDef(I,3)
	CA(I,4) = CurDef(I,4)
	CA(I,5) = .F.
	CA(I,6) = .F.
ENDFOR
CREATE Cursor &CurName FROM ARRAY CA
RELEASE CA, CurDef
IF USED ( [DataDict] )
   USE IN  DataDict
ENDIF
ENDPROC


PROCEDURE GetNextKey
PARAMETERS strAccess, strTable

DO CASE
   CASE strAccess = [DBF]
		IF NOT FILE (  [KEYFIELDS.DBF] )
		   CREATE TABLE KEYFIELDS ( KeyField Character(10), LastKey Integer )
		   USE IN		KEYFIELDS
		ENDIF
		THIS.OpenDBF ( [KeyFields] )
		LOCATE FOR UPPER(KeyField) = UPPER(strTable)
		IF NOT FOUND()
		   APPEND BLANK
		   REPLACE KeyField WITH UPPER(strTable)
		ENDIF
		REPLACE LastKey WITH LastKey + 1
		NewKey = TRANSFORM ( LastKey )
		USE IN KeyFields
		RETURN NewKey
   CASE strAccess = [SQL]
* You may want to replace this with a stored procedure
* that does both operations in one step.
		Cmd	= [SELECT COUNT(*) FROM KeyFields ]	;
		+ [ WHERE KeyField ='] + strTable + [']
		lr	= SQLEXEC ( THIS.Handle, Cmd )
		IF SQLResult.Exp = 0
		   Cmd	= [INSERT INTO KeyFields VALUES ('] + strTable + [', 0)]
		   lr	= SQLEXEC ( THIS.Handle, Cmd )
		ENDIF
		Cmd	= [UPDATE KeyFields SET LastKey = LastKey + 1]	;
			+ [ WHERE KeyField ='] + strTable + [']
		lr	= SQLEXEC ( THIS.Handle, Cmd )
		Cmd	= [SELECT LastKey FROM KeyFields ]	;
			+ [ WHERE KeyField = '] + strTable + [']
		lr	= SQLEXEC ( THIS.Handle, Cmd )
		NewKey	= TRANSFORM ( SQLResult.LastKey )
		USE IN SQLResult
		RETURN NewKey
   CASE strAccess = [WWW]
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		lcStr = THIS.Prefix + [GetNextKey~] + strTable
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		IF lcBuffer = [Error]
		   MESSAGEBOX( lcBuffer )
		 ELSE
		   RETURN lcBuffer
		ENDIF
ENDCASE
ENDPROC


PROCEDURE GetARecord
PARAMETERS strAccess, strTable, strKeyField, strKeyValue, strTagName
lcKeyType = VARTYPE ( strTable + [.] + strKeyField )
IF lcKeyType = [C]
   lcSQLValue = ['] + strKeyValue + [']
   lcDBFValue =       strKeyValue
 ELSE
   lcSQLValue =       strKeyValue
   lcDBFValue = VAL ( strKeyValue )
ENDIF
DO CASE
   CASE strAccess = [DBF]
		=SEEK ( lcDBFValue, strTable, strTagName )
   CASE strAccess = [SQL]
		Cmd = [SELECT * FROM ] + strTable	;
			+ [ WHERE ] + strKeyField + [ = ] + lcSQLValue
		lr  = SQLEXEC( THIS.Handle, Cmd )
		SELECT ( strTable )
		ZAP
		APPEND FROM DBF([SQLResult])
		USE IN SQLResult
   CASE strAccess = [WWW]
		Cmd = [SELECT * FROM ] + strTable	;
			+ [ WHERE ] + strKeyField + [ = ] + lcSQLValue
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [GetARecord]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		SELECT ( strTable )
		ZAP
		THIS.Transport ( lcBuffer, strTable )
ENDCASE
THIS.BlankEmptyDates
ENDPROC


PROCEDURE BlankEmptyDates
FOR I = 1 TO FCOUNT()
	Fld = FIELD(I)
	IF TYPE ( Fld ) = [D]
	   IF	 &Fld   = {01/01/1900}
	         REPLACE &Fld WITH {//}
	   ENDIF
	ENDIF
ENDFOR


PROCEDURE GetPrevRecord
PARAMETERS strAccess, strTable, strKeyField, strKeyValue

lcKeyType  = VARTYPE ( EVALUATE ( strTable + [.] + strKeyField ) )
lcKeyValue = TRANSFORM ( EVALUATE ( strTable + [.] + strKeyField ) )
IF lcKeyType = [C]
   lcKeyValue = ['] + lcKeyValue + [']
ENDIF

DO CASE
   CASE strAccess = [SQL]
		Cmd = [SELECT TOP 1 * FROM ] + strTable	;
			+ [ WHERE ] + strKeyField + [ < ] + lcKeyValue	;
			+ [ ORDER BY ] + strKeyField + [ DESC]
		lr  = SQLEXEC( THIS.Handle, Cmd )
		IF RECCOUNT() > 0
		   SELECT ( strTable )
		   ZAP
		   APPEND FROM DBF([SQLResult])
		ENDIF
		USE IN SQLResult
   CASE strAccess = [WWW]
		Cmd = [SELECT TOP 1 * FROM ] + strTable	;
			+ [ WHERE ] + strKeyField + [ < ] + lcKeyValue	;
			+ [ ORDER BY ] + strKeyField + [ DESC]
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [GetARecord]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		SELECT ( strTable )
		ZAP
		THIS.Transport ( lcBuffer, strTable )
ENDCASE
THIS.BlankEmptyDates
ENDPROC


PROCEDURE GetNextRecord
PARAMETERS strAccess, strTable, strKeyField, strKeyValue

lcKeyType  = VARTYPE ( EVALUATE ( strTable + [.] + strKeyField ) )
lcKeyValue = TRANSFORM ( EVALUATE ( strTable + [.] + strKeyField ) )
IF lcKeyType = [C]
   lcKeyValue = ['] + lcKeyValue + [']
ENDIF

DO CASE
   CASE strAccess = [SQL]
		Cmd = [SELECT TOP 1 * FROM ] + strTable	;
			+ [ WHERE ] + strKeyField + [ > ] + lcKeyValue ;
			+ [ ORDER BY ] + strKeyField
		lr  = SQLEXEC( THIS.Handle, Cmd )
		IF RECCOUNT() > 0
		   SELECT ( strTable )
		   ZAP
		   APPEND FROM DBF([SQLResult])
		ENDIF
		USE IN SQLResult
   CASE strAccess = [WWW]
		Cmd = [SELECT TOP 1 * FROM ] + strTable	;
			+ [ WHERE ] + strKeyField + [ > ] + lcKeyValue ;
			+ [ ORDER BY ] + strKeyField
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [GetARecord]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		SELECT ( strTable )
		ZAP
		THIS.Transport ( lcBuffer, strTable )
ENDCASE
THIS.BlankEmptyDates
ENDPROC


PROCEDURE GetFilteredQuery
PARAMETERS strAccess, strCmd, strCursor

DO CASE
   CASE strAccess = [DBF]
		Cmd = strCmd + [ INTO CURSOR ] + strCursor + [ NOFILTER]
		&Cmd
		RETURN [Ok]
   CASE strAccess = [SQL]
		lr  = SQLEXEC( THIS.Handle, Cmd, strCursor )
		IF lr < 0
		   MESSAGEBOX( [SQL command failed] )
		   SET STEP ON
		  ELSE
		   RETURN [Ok]
		ENDIF
   CASE strAccess = [WWW]
   		IF NOT USED ( strCursor )
		   THIS.CreateCursor ( strCursor )
		ENDIF
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [GetFilteredRecords]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		SELECT ( strCursor )
		IF lcBuffer = [Error]
		   MESSAGEBOX ( lcBuffer, 64, _VFP.Caption )
		  ELSE
		   THIS.Transport ( lcBuffer, strCursor )
		ENDIF
ENDCASE
ENDPROC


PROCEDURE GetAllRecords
PARAMETERS strAccess, strTable, strCursor, strOrder

IF EMPTY ( strOrder )
   strOrder = []
ENDIF
Msg = THIS.GetFilteredRecords ( strAccess, [*], strTable, [], strCursor, strOrder )
RETURN Msg
ENDPROC


PROCEDURE GetFilteredRecords
PARAMETERS strAccess, strFieldNames, strTable, WhereClause, strCursor, strOrderBy

IF NOT [ORDER] $ strOrderBy
   strOrderBy = []
ENDIF
DO CASE
   CASE strAccess = [DBF]
		Cmd = [SELECT ] + strFieldNames + [ FROM ] + strTable + WhereClause ;
			+ [ INTO CURSOR ] + strCursor + [ NOFILTER] + strOrderBy
		&Cmd
		RETURN [Ok]
   CASE strAccess = [SQL]
		Cmd = [SELECT ] + strFieldNames + [ FROM ] + strTable + WhereClause + strOrderBy
		lr  = SQLEXEC( THIS.Handle, Cmd, strCursor )
		IF lr < 0
		   MESSAGEBOX( [SQL command failed] )
		   SET STEP ON
		  ELSE
		   RETURN [Ok]
		ENDIF
   CASE strAccess = [WWW]
		IF NOT USED ( strCursor )
		   THIS.CreateCursor ( strCursor )
		ENDIF
		Cmd = [SELECT ] + strFieldNames + [ FROM ] + strTable + WhereClause && + strOrderBy
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [GetFilteredRecords]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		SELECT ( strCursor )
		IF lcBuffer = [Error]
		   MESSAGEBOX ( lcBuffer, 64, _VFP.Caption )
		  ELSE
		   THIS.Transport ( lcBuffer, strCursor )
		ENDIF
ENDCASE
ENDPROC


PROCEDURE GetSearchRecords
PARAMETERS strAccess, strFieldNames, strTable, WhereClause, strCursor, strOrderBy

IF NOT [ORDER] $ strOrderBy
   strOrderBy = []
ENDIF
DO CASE
   CASE strAccess = [DBF]
		Cmd = [SELECT ] + strFieldNames + [ FROM ] + strTable + WhereClause ;
			+ [ INTO CURSOR ] + strCursor + [ NOFILTER] + strOrderBy
		&Cmd
		RETURN [Ok]
   CASE strAccess = [SQL]
		Cmd = [SELECT ] + strFieldNames + [ FROM ] + strTable + WhereClause + strOrderBy
		lr  = SQLEXEC( THIS.Handle, Cmd, strCursor )
		IF lr < 0
		   MESSAGEBOX( [SQL command failed] )
		   SET STEP ON
		  ELSE
		   RETURN [Ok]
		ENDIF
   CASE strAccess = [WWW]
*!*			THIS.CreateView ( strTable )
		Cmd = [SELECT ] + strFieldNames + [ FROM ] + strTable + WhereClause && + strOrderBy
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [GetFilteredRecords]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		SELECT ( strTable )
		IF lcBuffer = [Error]
		   MESSAGEBOX ( lcBuffer, 64, _VFP.Caption )
		  ELSE
		   THIS.Transport ( lcBuffer,  [View] + strTable )
		ENDIF
ENDCASE
ENDPROC


PROCEDURE GetChildRecords
PARAMETERS strAccess, strParentTable,  strParentKey, strChildTable

lcKey = TRANSFORM ( EVALUATE ( strParentTable  + [.] + strParentKey ) )
Cmd = [SELECT * ] + [ FROM ]  + strChildTable 	;
  + [ WHERE ] + strParentKey + [ = ] + lcKey	;
  + [ ORDER BY LineNum]
DO CASE
   CASE strAccess = [DBF]
		Cmd = Cmd + [ INTO CURSOR SQLResult]
		&Cmd
   CASE strAccess = [SQL]
		lr = SQLEXEC( THIS.Handle, Cmd )
		SELECT ( strChildTable )
		ZAP
		IF USED ( [SQLResult] )
		   APPEND FROM DBF ( [SQLResult] )
		   USE IN SQLResult
		ENDIF
   CASE strAccess = [WWW]
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [GetFilteredRecords]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		SELECT ( strChildTable )
		ZAP
		IF lcBuffer = [Error]
		   MESSAGEBOX ( lcBuffer, 64, _VFP.Caption )
		  ELSE
		   THIS.Transport ( lcBuffer, strChildTable )
		ENDIF
ENDCASE
ENDPROC


PROCEDURE DeleteRecord 
PARAMETERS strAccess, strTable, strKeyField, strKeyValue

DO CASE
   CASE strAccess = [SQL]
		cmd = [DELETE ] + strTable	;
			+ [ WHERE ] + strKeyField + [ = ] + strKeyValue
		SQLEXEC( THIS.Handle, Cmd )
   CASE strAccess = [WWW]
		cmd = [DELETE ] + strTable	;
			+ [ WHERE ] + strKeyField + [ = ] + strKeyValue
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [SPT]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		SELECT ( strChildTable )
ENDCASE
ENDPROC


PROCEDURE FindChildRec
PARAMETERS strAccess, strChildTable, strKey

SELECT ( strChildTable )
IF strAccess = [DBF]
   =SEEK ( strKey, strChildTable )
  ELSE
   LOCATE FOR LineNum = VAL ( RIGHT ( strKey, 2 ) )
ENDIF
ENDPROC


PROCEDURE DeleteChildRec
PARAMETERS strAccess, strParentTable, strParentKey, strChildTable, strKey

lcKeyVal = TRANSFORM(EVAL ( strParentTable + [.] + strParentKey ) )
Cmd = [DELETE FROM ] + strChildTable					;
	+      [ WHERE ] + strParentKey + [ = ] + lcKeyVal	;
	+        [ AND LineNum = ] + lcLine
DO CASE
   CASE strAccess = [DBF]
		&cmd
   CASE strAccess = [SQL]
		lr = SQLEXEC ( THIS.Handle, Cmd )
   CASE strAccess = [WWW]
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [SPT]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
ENDCASE
ENDPROC


PROCEDURE DeleteParentAndChild
PARAMETERS strAccess, strParent, strParentKey, strChild

lcKeyVal = TRANSFORM(EVAL ( strParent + [.] + strParentKey ) )
Cmd1 = [DELETE FROM ] + strChild	+ [ WHERE ] + strParentKey + [ = ] + lcKeyVal
Cmd2 = [DELETE FROM ] + strParent	+ [ WHERE ] + strParentKey + [ = ] + lcKeyVal
DO CASE
   CASE strAccess = [DBF]
		&Cmd1
		&Cmd2
   CASE strAccess = [SQL]
		lr = SQLEXEC ( THIS.Handle, Cmd1 )
		lr = SQLEXEC ( THIS.Handle, Cmd2 )
   CASE strAccess = [WWW]
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], Cmd1 )
		lcStr = THIS.Prefix + [SPT]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], Cmd2 )
		lcStr = THIS.Prefix + [SPT]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
ENDCASE
ENDPROC


PROCEDURE SaveRecord
PARAMETERS strAccess, strTable, strKey, lAdding

IF strAccess = [DBF]		&& already handled in form classes
   RETURN
ENDIF
IF lAdding
   THIS.SendInsert ( strAccess, strTable, strKey )
  ELSE
   THIS.SendUpdate ( strAccess, strTable, strKey )
ENDIF
ENDPROC


PROCEDURE SendInsert
PARAMETERS strAccess, strTable, strKeyField

Cmd = [INSERT ] + StrTable + [ VALUES ( ]
FOR I = 1 TO FCOUNT()
	Fld = FIELD(I)
	Dta = ALLTRIM(TRANSFORM ( &Fld ))
	Dta = CHRTRAN ( Dta, CHR(39), CHR(146) )		&& get rid of single quotes in the data
	Dta = IIF ( Dta = [/  /], [], Dta )
	Dta = IIF ( Dta = [.F.], [0], Dta )
	Dta = IIF ( Dta = [.T.], [1], Dta )
	Dlm = IIF ( VARTYPE ( &Fld ) = [C], ['],	;
	      IIF ( VARTYPE ( &Fld ) = [D], ['],	;
	      IIF ( VARTYPE ( &Fld ) = [I], [],		;
	      IIF ( VARTYPE ( &Fld ) = [N], [],		;
	      IIF ( VARTYPE ( &Fld ) = [D], ['],	;
	      IIF ( VARTYPE ( &Fld ) = [M], ['],[]))))))
	Cmd = Cmd + Dlm + Dta + Dlm + [,]
ENDFOR
Cmd = LEFT ( Cmd, LEN(Cmd) -1) + [ )]  && Remove "," add " )"

DO CASE
   CASE strAccess = [SQL]
		lr  = SQLEXEC ( THIS.Handle, Cmd )
		IF lr < 0
		   MESSAGEBOX( [SQL Command failed - error code ] + TRANSFORM ( lr ) )
		   SET STEP ON
		ENDIF
   CASE strAccess = [WWW]
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [SPT]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		IF lcBuffer = [Error]
		   MESSAGEBOX ( lcBuffer, 64, _VFP.Caption )
		ENDIF
ENDCASE

ENDPROC


PROCEDURE SendUpdate
PARAMETERS strAccess, strTable, strKeyField

Cmd = [UPDATE ] + StrTable + [ SET ]
FOR I = 1 TO FCOUNT()
	IF FIELD(I) = UPPER(StrKeyField)
	   LOOP
	ENDIF
	Fld = FIELD(I)
	Dta = ALLTRIM(TRANSFORM ( &Fld ))
	Dta = CHRTRAN ( Dta, CHR(39), CHR(146) )		&& get rid of single quotes in the data
	Dta = IIF ( Dta = [/  /], [], Dta )
	Dta = IIF ( Dta = [.F.], [0], Dta )
	Dta = IIF ( Dta = [.T.], [1], Dta )
	Dlm = IIF ( VARTYPE ( &Fld ) = [C], ['],	;
	      IIF ( VARTYPE ( &Fld ) = [D], ['],	;
	      IIF ( VARTYPE ( &Fld ) = [I], [],		;
	      IIF ( VARTYPE ( &Fld ) = [N], [],		;
	      IIF ( VARTYPE ( &Fld ) = [D], ['],	;
	      IIF ( VARTYPE ( &Fld ) = [M], ['],[]))))))
	Cmd = Cmd + Fld + [ = ] + Dlm + Dta + Dlm + [,]
ENDFOR
lcKeyType	= VARTYPE   ( EVALUATE ( strTable + [.] + strKeyField ) )
lcKeyValue	= TRANSFORM ( EVALUATE ( strTable + [.] + strKeyField ) )
lcSQLValue	= IIF ( lcKeyType = [C], ['] + lcKeyValue + ['], lcKeyValue ) 
Cmd 		= LEFT ( Cmd, LEN(Cmd) -1 )	;
			+ [ WHERE ] + strKeyField + [ = ] + lcSQLValue

DO CASE
   CASE strAccess = [SQL]
		lr  = SQLEXEC ( THIS.Handle, Cmd )
		IF lr < 0
		   MESSAGEBOX( [SQL Command failed - error code ] + TRANSFORM ( lr ) )
		   SET STEP ON
		ENDIF
   CASE strAccess = [WWW]
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [SPT]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		IF lcBuffer = [Error]
		   MESSAGEBOX ( lcBuffer, 64, _VFP.Caption )
		ENDIF
ENDCASE
ENDPROC


PROCEDURE SaveChildRecord
PARAMETERS strAccess, strType, strParent, strParentKey, strChild, strLineNum

DO CASE
   CASE strAccess = [SQL]
		IF strType = [Added]
		   oDataMgr.SendInsert ( strAccess, strChild )
		 ELSE
		   oDataMgr.SendChildUpdate ( ;
					strAccess, strParent, strParentKey, strChild, strLineNum )
		ENDIF
   CASE strAccess = [WWW]
		IF strType = [Added]
		   oDataMgr.SendInsert ( strAccess, strChild )
		 ELSE
		   oDataMgr.SendChildUpdate ( ;
					strAccess, strParent, strParentKey, strChild, strLineNum )
		ENDIF
ENDCASE
ENDPROC


PROCEDURE SendChildUpdate
PARAMETERS strAccess, strTable, strParentKey, strChild, strLineNum

Cmd = [UPDATE ] + StrChild + [ SET ]
FOR I = 1 TO FCOUNT()
	IF  FIELD(I) = UPPER(strParentKey)	;
	 OR FIELD(I) = [LINENUM]
	   LOOP
	ENDIF
	Fld = FIELD(I)
	Dta = ALLTRIM(TRANSFORM ( &Fld ))
	Dta = IIF ( Dta = [/  /], [], Dta )
	Dta = IIF ( Dta = [.F.], [0], Dta )
	Dta = IIF ( Dta = [.T.], [1], Dta )
	Dlm = IIF ( VARTYPE ( &Fld ) = [C], ['],	;
	      IIF ( VARTYPE ( &Fld ) = [D], ['],	;
	      IIF ( VARTYPE ( &Fld ) = [I], [],		;
	      IIF ( VARTYPE ( &Fld ) = [N], [],		;
	      IIF ( VARTYPE ( &Fld ) = [D], ['],	;
	      IIF ( VARTYPE ( &Fld ) = [M], ['],[]))))))
	Cmd = Cmd + Fld + [ = ] + Dlm + Dta + Dlm + [,]
ENDFOR

lcKeyValue = TRANSFORM ( EVALUATE ( strTable + [.] + strParentKey ) )
Cmd = LEFT ( Cmd, LEN(Cmd) -1 )	;
	+ [ WHERE ] + strParentKey + [ = ] + lcKeyValue	;
	+ [   AND LineNum = ] + strLineNum

DO CASE
   CASE strAccess = [SQL]
		lr  = SQLEXEC ( THIS.Handle, Cmd )
   CASE strAccess = [WWW]
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [SPT]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		IF lcBuffer = [Error]
		   MESSAGEBOX ( lcBuffer, 64, _VFP.Caption )
		ENDIF
ENDCASE
ENDPROC


PROCEDURE CountRecs
PARAMETERS strTable

LOCAL lnNumRecs
DO CASE
   CASE DataAccess = [SQL]
		lr = SQLEXEC( THIS.Handle, [SELECT COUNT(*) AS NumRecs FROM ] + strTable )
		IF USED ( [SQLResult] )
		   lnNumRecs = SQLResult.NumRecs
		   USE
		  ELSE
		   lnNumRecs = 0
		ENDIF
   CASE DataAccess = [WWW]
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		lcStr = THIS.Prefix + [CountRecs~] + strTable
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		lnNumRecs = VAL ( lcBuffer )
   OTHERWISE
		lnNumRecs = 0
ENDCASE
RETURN lnNumRecs
ENDPROC


PROCEDURE FormatAddress
PARAMETERS pCompID

IF EMPTY ( pCompID )
   RETURN []
ENDIF
SaveAlias = ALIAS()
lcAccess  = THIS.GetAccess ( [Company] )
lcStr     = []
DO CASE
   CASE lcAccess = [DBF]
		THIS.OpenDBF ( [Company], [CompID] )
		SEEK pCompID
		lcStr = ALLTRIM(COMPANY.Company) 			   + CHR(13) + CHR(10)
		lcStr = lcStr + ALLTRIM(COMPANY.Address1) 	   + CHR(13) + CHR(10)
		IF NOT EMPTY ( COMPANY.Address2 )
		   LcStr = lcStr + ALLTRIM(COMPANY.Address2)   + CHR(13) + CHR(10)
		ENDIF
		lcStr = lcStr + ALLTRIM(COMPANY.City)+[, ]     ;
			  + ALLTRIM(COMPANY.State) + [ ] + COMPANY.Zip
   CASE lcAccess = [SQL]
   		Cmd = [SELECT * FROM Company WHERE CompID = ]  + TRANSFORM(pCompID)
   		lr  = SQLEXEC( THIS.Handle, Cmd )
		lcStr = ALLTRIM(SQLResult.Company) 			   + CHR(13) + CHR(10)
		lcStr = lcStr + ALLTRIM(SQLResult.Address1)    + CHR(13) + CHR(10)
		IF NOT EMPTY ( SQLResult.Address2 )
		   LcStr = lcStr + ALLTRIM(SQLResult.Address2) + CHR(13) + CHR(10)
		ENDIF
		lcStr = lcStr + ALLTRIM(SQLResult.City)+[, ]   ;
			  + ALLTRIM(SQLResult.State) + [ ] + SQLResult.Zip
		USE IN SQLResult
ENDCASE
IF NOT EMPTY ( SaveAlias )
   SELECT    ( SaveAlias )
ENDIF
RETURN lcStr
ENDPROC


PROCEDURE MakeSQLTable
PARAMETERS strTable

SaveAlias = ALIAS()
SELECT 0
USE ( strTable )
AFIELDS(Flds)
Tbl = ALIAS()
Cmd = ( [DROP TABLE ] + strTable )
lr  = SQLEXEC( THIS.Handle, Cmd  )
cmd = [CREATE TABLE ] + Tbl + [ ( ]
FOR I = 1 TO ALEN(Flds,1)
	Fld = Flds(I,1)
	Typ = Flds(I,2)
	DO CASE
	   CASE Typ = [C]
			Typ = [Char(] + TRANSFORM(Flds(I,3))+[) NOT NULL DEFAULT '']
	   CASE Typ $ [DT]
			Typ = [DateTime NOT NULL DEFAULT '']
	   CASE Typ = [I]
			Typ = [Integer NOT NULL DEFAULT 0]
	   CASE Typ = [N]
			Typ = [Numeric(] + TRANSFORM(Flds(I,3)) + [,] + TRANSFORM(Flds(I,4)) + [) NOT NULL DEFAULT 0]
	   CASE Typ = [L]
			Typ = [Bit NOT NULL DEFAULT 0]
	   CASE Typ = [M]
			Typ = [Text NOT NULL DEFAULT '']
	ENDCASE
	Cmd = Cmd + Fld + [ ] + Typ + [, ] + CHR(13)
ENDFOR
Cmd = LEFT(Cmd,LEN(Cmd)-3) + [ )]
USE
IF NOT EMPTY ( SaveAlias )
   SELECT    ( SaveAlias )
ENDIF
lr = SQLEXEC( THIS.Handle, Cmd )
ENDPROC


PROCEDURE Upload
PARAMETERS strTable

SaveAlias = ALIAS()
SELECT 0
USE ( strTable )
WAIT WINDOW [Loading table ] + strTable NOWAIT
AFIELDS(Flds)
Tbl = ALIAS()
SCAN
	WAIT WINDOW [Loading record ] + TRANSFORM(RECNO()) NOWAIT
 	Cmd = [INSERT INTO ] + Tbl + [ VALUES ( ]
	FOR I = 1 TO ALEN(Flds,1)
		Fld = Flds(I,1)
		Typ = Flds(I,2)
		DO CASE
		   CASE Typ $ [CM]
				Dta = ['] + CHRTRAN ( ALLTRIM(TRANSFORM(&Fld)), CHR(39),CHR(146)) + [']
		   CASE Typ $ [DT]
				Dta = ['] + TRANSFORM(&Fld) + [']
				IF YEAR ( &Fld. ) < 1900
				   Dta = ['']
				ENDIF
		   CASE Typ = [I]
				Dta =       TRANSFORM(&Fld)
		   CASE Typ = [N]
		   		Ln  = TRANSFORM(Flds(I,3))
		   		Dc  = TRANSFORM(Flds(I,4))
				Dta = STR(&Fld,&Ln,&Dc)
		   CASE Typ = [L]
				Dta = IIF(&Fld,[0],[1])
		ENDCASE
		Cmd = Cmd + Dta + [,]
	ENDFOR
	Cmd = LEFT(Cmd,LEN(Cmd)-1) + [ )]
	lr = SQLEXEC( THIS.Handle, Cmd )
	IF lr < 0
	   lcStr = [RECNO() = ] + TRANSFORM ( RECNO() )
	   STRTOFILE( lcStr, ( strTable + [Errors.txt] ), .T. )
	ENDIF
ENDSCAN
USE
IF NOT EMPTY ( SaveAlias )
   SELECT    ( SaveAlias )
ENDIF
ENDPROC


PROCEDURE GridChanged
PARAMETERS strAccess, strParent, strParentKey, strChild, ;
		   strQty,    strUpr,    strExt,       strTxbl,    strLine

IF strAccess = [SQL] OR STRAccess = [WWW]
   strTxbl = IIF ( [F] $ strTxbl, [0], [1] )
ENDIF

strKey  = TRAN ( EVAL ( strParent + [.] + strParentKey ) )

Cmd = [UPDATE ] + strChild
Cmd = Cmd + [ SET Quantity = ] + strQty  + [, ]
Cmd = Cmd + [     UnitPrice= ] + strUpr  + [, ]
Cmd = Cmd + [     Taxable  = ] + strTxbl + [, ]
Cmd = Cmd + [     Extended = ] + strExt
Cmd = Cmd + [ WHERE ] + strParentKey + [ = ] + strKey
Cmd = Cmd + [ AND LineNum = ]  + strLine

DO CASE
   CASE strAccess = [DBF]
		&Cmd
   CASE strAccess = [SQL]
		lr = SQLEXEC( THIS.Handle, Cmd )
		IF lr < 0
		   MESSAGEBOX( [SQL Update failed!], 64, _VFP.Caption )
		   SET STEP ON
		ENDIF
   CASE strAccess = [WWW]
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [SPT]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		IF lr < 0 OR lcBuffer = [Error]
		   MESSAGEBOX( [SQL command failed] )
		   SET STEP ON
		ENDIF
ENDCASE
ENDPROC


PROCEDURE Download
PARAMETERS strAccess, strTable

strTable = ALLTRIM(strTable)

DO CASE

   CASE strAccess = [SQL]
		Cmd = [SELECT * FROM ] + strTable
		lr  = SQLEXEC( THIS.Handle, Cmd )
		SELECT 0
		USE ( strTable )
		ZAP
		APPEND FROM DBF([SQLResult])
		MESSAGEBOX( TRANSFORM(_Tally) + [ records downloaded], 64, _VFP.Caption, 500 )
		USE
		USE IN SQLResult

   CASE strAccess = [WWW]

		lcBuffer = []
		lnBufLen = 0
		UnableToConnect = [Error: Unable to connect to the web server]
		lr = oIP.HttpConnect ( THIS.IPAddress )
		IF lr < 0
		   MessageBox( UnableToConnect, 64, _VFP.Caption, 2000 )
		   RETURN
		ENDIF
		cmd = THIS.Prefix + [GetTable~] + strTable
		lr = oIP.HTTPGetEx   ( cmd, @lcBuffer, @lnBufLen )
		IF lr < 0
		   MessageBox( UnableToConnect, 64, _VFP.Caption, 2000 )
		   RETURN [Error: Can't connect to data server]
		ENDIF
		SELECT ( strTable )
		ZAP
		THIS.Transport ( lcBuffer, strTable )

ENDCASE
ENDPROC


PROCEDURE Post
PARAMETERS strAccess, strTable, strKeyName

DO CASE
   CASE strAccess = [SQL]
   		lcKeyValue = TRANSFORM ( EVALUATE ( strTable + [.] + strKeyName ) )
		Cmd = [UPDATE ] + strTable   + [ SET Posted = 1]	;
			+ [ WHERE ] + strKeyName + [ = ] + lcKeyValue
		lr = SQLEXEC( THIS.Handle, Cmd )
ENDCASE
ENDPROC


FUNCTION GetMemberCount
PARAMETERS strAccess

DO CASE

   CASE strAccess = [DBF]

		IF NOT USED ( [Cases] )
		   RETURN [Error: Cases table not open]
		ENDIF
		SELECT Members
		SET ORDER TO Member		&& CaseNum + STR(Sequence,2) + AlienNum
		SEEK Cases.CaseNum
		COUNT TO RecKount WHILE CaseNum = CASES.CaseNum
		RETURN RecKount

   CASE strAccess = [SQL]

		Cmd = [SELECT COUNT(*) AS RecCount FROM MEMBERS WHERE CaseNum = '] + TRANSFORM(Cases.CaseNum) + [']
		SQLEXEC( THIS.Handle, Cmd )
		lnRecCount = SQLResult.RecCount
		USE IN SQLResult
		RETURN lnRecCount

   CASE strAccess = [WWW]

		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		Cmd = [SELECT COUNT(*) AS RecCount FROM MEMBERS WHERE CaseNum = '] + TRANSFORM(Cases.CaseNum) + [']
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [GetFilteredRecords]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		IF lr < 0 OR lcBuffer = [Error]
		   MESSAGEBOX( [SQL command failed] )
		   SET STEP ON
		ENDIF
		CREATE CURSOR RECCOUNT( RecCount Integer )
		THIS.Transport ( lcBuffer, [Reccount] )
		lnRecCount = Reccount.Reccount
		USE IN RecCount
		RETURN lnRecCount

ENDCASE
ENDFUNC


FUNCTION GetCurrentMember
PARAMETERS strAccess, numRecNum

DO CASE

   CASE strAccess = [DBF]

		IF NOT USED ( [Cases] )
		   RETURN [Error: Cases table not open]
		ENDIF
		SELECT Members
		SET ORDER TO Member		&& CaseNum + STR(Sequence,2) + AlienNum
		SEEK Cases.CaseNum
		IF numRecNum > 1
		   SKIP ( numRecNum - 1 )
		ENDIF
*!*		What was this for?
*!*			SCATTER MEMVAR
*!*			SELECT Members
*!*			ZAP
*!*			GATHER MEMVAR
* Get matching ESL record
		SELECT ESL
		IF NOT SEEK ( Members.AlienNum, [ESL], [ESL] )		&& AlienNum + Class
		   APPEND BLANK
		   REPLACE AlienNum WITH MEMBERS.AlienNum, CaseNum WITH MEMBERS.CaseNum
		ENDIF
		SELECT  Members

   CASE strAccess = [SQL]

		Cmd = [SELECT * FROM Members WHERE CaseNum  = '] + TRANSFORM(Cases.CaseNum) + [' ORDER BY Sequence]
		SQLEXEC( THIS.Handle, Cmd )
		SELECT MEMBERS
		ZAP
		APPEND FROM DBF([SQLResult])
		USE IN SQLResult
		SET DELETED OFF
		DELETE ALL
		IF numRecNum > 0 AND RECCOUNT() > 0
			GO numRecNum
			RECALL NEXT 1
		ENDIF
		RECALL NEXT 1
		SET DELETED ON		&& Can't PACK
		GO TOP
* Get ESL record
		Cmd = [SELECT * FROM ESL WHERE AlienNum = '] + Members.AlienNum + [']
		SQLEXEC( THIS.Handle, Cmd )
		IF RECCOUNT("SQLResult") = 0
		   INSERT INTO ESL ( CaseNum, AlienNum ) VALUES ( Members.CaseNum, Members.AlienNum )
		   Cmd = [SELECT * FROM ESL WHERE AlienNum = '] + Members.AlienNum + [']
		   SQLEXEC( THIS.Handle, Cmd )
		ENDIF
		SELECT ESL
		ZAP
		APPEND FROM DBF([SQLResult])
		THIS.BlankEmptyDates
		USE IN SQLResult
		SELECT Members

   CASE strAccess = [WWW]

		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		Cmd = [SELECT * FROM Members WHERE CaseNum  = '] + TRANSFORM(Cases.CaseNum) + [' ORDER BY Sequence]
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [GetFilteredRecords]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		IF lr < 0 OR lcBuffer = [Error]
		   MESSAGEBOX( [SQL command failed] )
		   SET STEP ON
		ENDIF
		SELECT MEMBERS
		ZAP
		THIS.Transport ( lcBuffer, [Members] )
		SET DELETED OFF
		DELETE ALL
		IF numRecNum > 0 AND RECCOUNT() > 0
			GO numRecNum
			RECALL NEXT 1
		ENDIF
		SET DELETED ON		&& Can't PACK
		GO TOP
		THIS.BlankEmptyDates

* Get matching ESL record; if none exists, create one.
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		Cmd = [SELECT * FROM ESL WHERE AlienNum  = '] + Members.AlienNum + [']
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [GetFilteredRecords]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		IF lr < 0 OR lcBuffer = [Error]
		   MESSAGEBOX( [SQL command failed] )
		   SET STEP ON
		ENDIF
		SELECT ESL
		ZAP
		THIS.Transport ( lcBuffer, [ESL] )
		IF RECCOUNT() = 0
		   INSERT INTO ESL ( CaseNum, AlienNum ) VALUES ( MEMBERS.CaseNum, MEMBERS.AlienNum )
		   Cmd	= [INSERT INTO ESL ( CaseNum, AlienNum ) VALUES ( '] ;
				+ MEMBERS.CaseNum ;
				+ [', '] + MEMBERS.AlienNum + [' )]

			lr = oIP.HTTPConnect ( THIS.IPAddress )
			IF lr < 0
			   MESSAGEBOX( [WWW command failed] )
			   RETURN [Error]
			ENDIF
			lcBuffer = []
			lnBufLen = 0
			oIP.AddPostKey ( [RESET] )
			oIP.AddPostKey ( [Cmd], Cmd )
			lcStr = THIS.Prefix + [SPT]
			lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		ENDIF
		THIS.BlankEmptyDates
		SELECT Members

ENDCASE
ENDFUNC


FUNCTION GetMoveCount
PARAMETERS strAccess

DO CASE

   CASE strAccess = [DBF]

		SELECT Moves
		SET ORDER TO CaseSeq		&& CaseNum + STR(Sequence,2)
		SEEK Cases.CaseNum
		COUNT TO RecKount WHILE CaseNum = CASES.CaseNum
		RETURN RecKount

   CASE strAccess = [SQL]

		Cmd = [SELECT COUNT(*) AS RecCount FROM Moves WHERE CaseNum = '] + TRANSFORM(Cases.CaseNum) + [']
		SQLEXEC( THIS.Handle, Cmd )
		lnRecCount = SQLResult.RecCount
		USE IN SQLResult
		RETURN lnRecCount

   CASE strAccess = [WWW]

		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		Cmd = [SELECT COUNT(*) AS RecKount FROM Moves WHERE CaseNum = '] + TRANSFORM(Cases.CaseNum) + [']
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [GetFilteredRecords]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		IF lr < 0 OR lcBuffer = [Error]
		   MESSAGEBOX( [SQL command failed] )
		   SET STEP ON
		ENDIF
		SaveAlias = ALIAS()
		CREATE CURSOR SQLResult ( RecKount Integer(4) )
		THIS.Transport ( lcBuffer, [SQLResult] )
		lnRecCount = SQLResult.RecKount
		USE IN SQLResult
		IF NOT EMPTY ( SaveAlias )
		   SELECT	 ( SaveAlias )
		ENDIF
		RETURN lnRecCount

ENDCASE
ENDFUNC


FUNCTION GetCurrentMove
PARAMETERS strAccess, numRecNum

DO CASE

   CASE strAccess = [DBF]

		SELECT Moves
		SET ORDER TO CaseSeq		&& CaseNum + STR(Sequence,2)
		SEEK Cases.CaseNum
		IF numRecNum > 1
		   SKIP ( numRecNum - 1 )
		ENDIF

   CASE strAccess = [SQL]

		Cmd = [SELECT * FROM Moves WHERE CaseNum  = '] + TRANSFORM(Cases.CaseNum) + [' ORDER BY Sequence]
		SQLEXEC( THIS.Handle, Cmd )
		SELECT Moves
		ZAP
		APPEND FROM DBF([SQLResult])
		USE IN SQLResult
		SET DELETED ON
		DELETE ALL
		IF numRecNum > 0 AND RECCOUNT() > 0
			GO numRecNum
			RECALL NEXT 1
		ENDIF
		SET DELETED ON		&& Can't PACK
		GO TOP

   CASE strAccess = [WWW]

		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		Cmd = [SELECT * FROM Moves WHERE CaseNum  = '] + TRANSFORM(Cases.CaseNum) + [' ORDER BY Sequence]
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [GetFilteredRecords]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		IF lr < 0 OR lcBuffer = [Error]
		   MESSAGEBOX( [SQL command failed] )
		   SET STEP ON
		ENDIF
		SELECT Moves
		ZAP
		THIS.Transport ( lcBuffer, [Moves] )
		SET DELETED OFF
		DELETE ALL
		IF numRecNum > 0 AND RECCOUNT() > 0
			GO numRecNum
			RECALL NEXT 1
		ENDIF
		SET DELETED ON		&& Can't PACK
		GO TOP

ENDCASE
ENDFUNC


FUNCTION GetContactCount
PARAMETERS strAccess

DO CASE

   CASE strAccess = [DBF]

		IF NOT USED ( [Cases] )
		   RETURN [Error: Cases table not open]
		ENDIF
		SELECT Contacts
		SET ORDER TO Contact		&& CaseNum + STR(Sequence,2) + AlienNum
		SEEK Cases.CaseNum
		COUNT TO RecKount WHILE CaseNum = CASES.CaseNum
		RETURN RecKount

   CASE strAccess = [SQL]

		Cmd = [SELECT COUNT(*) AS RecCount FROM Contacts WHERE CaseNum = '] + TRANSFORM(Cases.CaseNum) + [']
		SQLEXEC( THIS.Handle, Cmd )
		lnRecCount = SQLResult.RecCount
		USE IN SQLResult
		RETURN lnRecCount

   CASE strAccess = [WWW]

		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		Cmd = [SELECT COUNT(*) AS RecCount FROM Contacts WHERE CaseNum = '] + TRANSFORM(Cases.CaseNum) + [']
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [GetFilteredRecords]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		IF lr < 0 OR lcBuffer = [Error]
		   MESSAGEBOX( [SQL command failed] )
		   SET STEP ON
		ENDIF
		CREATE CURSOR SQLResult ( Reccount Integer(4) )
		THIS.Transport ( lcBuffer, [SQLResult] )
		lnRecCount = SQLResult.RecCount
		USE IN SQLResult
		RETURN lnRecCount

ENDCASE
ENDFUNC


FUNCTION GetCurrentContact
PARAMETERS strAccess, numRecNum

DO CASE

   CASE strAccess = [DBF]

		SELECT Contacts
		SET ORDER TO Contact		&& CaseNum + STR(Sequence,2) + AlienNum
		SEEK Cases.CaseNum
		IF numRecNum > 1
		   SKIP ( numRecNum - 1 )
		ENDIF

   CASE strAccess = [SQL]

		Cmd = [SELECT * FROM Contacts WHERE CaseNum  = '] + TRANSFORM(Cases.CaseNum) + [' ORDER BY Date]
		SQLEXEC( THIS.Handle, Cmd )
		SELECT Contacts
		ZAP
		APPEND FROM DBF([SQLResult])
		USE IN SQLResult
		SET DELETED ON
		DELETE ALL
		IF numRecNum > 0 AND RECCOUNT() > 0
			GO numRecNum
			RECALL NEXT 1
		ENDIF
		SET DELETED ON		&& Can't PACK
		GO TOP

   CASE strAccess = [WWW]

		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed]   )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		lcStr = THIS.Prefix + [GetFilteredRecords]
		Cmd   = [SELECT * FROM Contacts WHERE CaseNum  = '] + TRANSFORM(Cases.CaseNum) + [' ORDER BY Date]
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [GetFilteredRecords]
		lr    = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		IF lr < 0 OR lcBuffer = [Error]
		   MESSAGEBOX( [SQL command failed] )
		   SET STEP ON
		ENDIF
		SELECT Contacts
		ZAP
		THIS.Transport ( lcBuffer, [Contacts] )
		SET DELETED OFF
		DELETE ALL
		IF numRecNum > 0 AND RECCOUNT() > 0
			GO numRecNum
			RECALL NEXT 1
		ENDIF
		SET DELETED ON		&& Can't PACK
		GO TOP

ENDCASE
ENDFUNC


FUNCTION GetAllContacts
PARAMETERS strAccess

DO CASE

   CASE strAccess = [DBF]

		SELECT Contacts
		SET ORDER TO Contact		&& CaseNum + STR(Sequence,2) + AlienNum
		SET FILTER TO CONTACTS.CaseNum = Cases.CaseNum

   CASE strAccess = [SQL]

		Cmd = [SELECT * FROM Contacts WHERE CaseNum  = '] + TRANSFORM(Cases.CaseNum) + [' ORDER BY Date]
		SQLEXEC( THIS.Handle, Cmd )
		SELECT Contacts
		ZAP
		APPEND FROM DBF([SQLResult])
		USE IN SQLResult

   CASE strAccess = [WWW]

		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed]   )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		lcStr = THIS.Prefix + [GetFilteredRecords]
		Cmd   = [SELECT * FROM Contacts WHERE CaseNum  = '] + TRANSFORM(Cases.CaseNum) + [' ORDER BY Date]
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [GetFilteredRecords]
		lr    = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		IF lr < 0 OR lcBuffer = [Error]
		   MESSAGEBOX( [SQL command failed] )
		   SET STEP ON
		ENDIF
		SELECT Contacts
		ZAP
		THIS.Transport ( lcBuffer, [Contacts] )

ENDCASE
GO TOP
ENDFUNC


FUNCTION GetCases
PARAMETERS strAccess, strCmd

DO CASE

   CASE strAccess = [DBF]

		Cmd = strCmd + [ INTO CURSOR C1]
		&Cmd
		IF RECCOUNT() > 0
		   SELECT CaseView
		   ZAP
		   APPEND FROM DBF ( [C1] )
		   USE IN C1
		   GO TOP
		ENDIF
		
   CASE strAccess = [SQL]

		lr = SQLEXEC( THIS.Handle, strCmd )
		IF lr < 0
		   MESSAGEBOX( "Error: Couldn't execute SQL command" + CHR(13) + strCmd )
		   RETURN
		ENDIF
		SELECT CaseView
		ZAP
		APPEND FROM DBF ( [SQLResult] )
		USE IN SQLResult
		GO TOP

   CASE strAccess = [WWW]

		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   MESSAGEBOX( [WWW command failed] )
		   RETURN [Error]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], strCmd )
		lcStr = THIS.Prefix + [GetFilteredRecords]
		lr    = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		IF lr < 0 OR lcBuffer = [Error]
		   MESSAGEBOX( [SQL command failed:] + CHR(13) + strCmd )
		   SET STEP ON
		   RETURN
		ENDIF
		SELECT CaseView
		ZAP
		=AFIELDS(A1)
		CREATE CURSOR C1 FROM ARRAY A1
		THIS.Transport ( lcBuffer, [C1] )
		SELECT CaseView
		APPEND FROM DBF ( [C1] )
		GO TOP
		USE IN C1

ENDCASE
ENDFUNC


PROCEDURE GetCheckRequests
PARAMETERS strAccess
DO CASE
   CASE strAccess = [DBF]
		SELECT CHECKS
		SET FILTER TO Status = [REQUEST]
		GO TOP
		RETURN [Ok]
   CASE strAccess = [SQL]
		Cmd = [SELECT * FROM CHECKS WHERE Status = 'REQUEST ' ORDER BY CheckNum]
		lr  = SQLEXEC( THIS.Handle, Cmd )
		IF lr < 0
		   MESSAGEBOX( [SQL command failed] )
		   SET STEP ON
		  ELSE
		   SELECT Checks
		   ZAP
		   APPEND FROM DBF ( [SQLResult] )
		   USE IN SQLResult
		   RETURN [Ok]
		ENDIF
   CASE strAccess = [WWW]
		Cmd = [SELECT * FROM CHECKS WHERE Status = 'REQUEST ' ORDER BY CheckNum]
		lr = oIP.HTTPConnect ( THIS.IPAddress )
		IF lr < 0
		   RETURN [SQL failed to return the requested check table]
		ENDIF
		lcBuffer = []
		lnBufLen = 0
		oIP.AddPostKey ( [RESET] )
		oIP.AddPostKey ( [Cmd], Cmd )
		lcStr = THIS.Prefix + [GetFilteredRecords]
		lr = oIP.HTTPGetEx ( lcStr, @lcBuffer, @lnBufLen )
		SELECT Checks
		IF lcBuffer = [Error]
		   RETURN lcBuffer
		  ELSE
		   THIS.Transport ( lcBuffer, [Checks] )
		   RETURN [Ok]
		ENDIF
ENDCASE
ENDPROC

ENDDEFINE